You need to sign in or sign up before continuing.
syntax-check.mk 79.6 KB
Newer Older
1 2 3 4
#
# Rules for running syntax-check, derived from gnulib's
# maint.mk
#
E
Eric Blake 已提交
5
# Copyright (C) 2008-2019 Red Hat, Inc.
6
# Copyright (C) 2003-2019 Free Software Foundation, Inc.
7 8 9 10 11 12 13 14 15 16 17 18

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
19 20
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
21

22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54
# This is reported not to work with make-3.79.1
# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
ME := $(_build-aux)/syntax-check.mk

# These variables ought to be defined through the configure.ac section
# of the module description. But some packages import this file directly,
# ignoring the module description.
AWK ?= awk
GREP ?= grep
SED ?= sed

# Helper variables.
_empty =
_sp = $(_empty) $(_empty)

# _equal,S1,S2
# ------------
# If S1 == S2, return S1, otherwise the empty string.
_equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))

GIT = git
VC = $(GIT)

VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)

# You can override this variable in syntax-check.mk to set your own regexp
# matching files to ignore.
VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$

# This is to preprocess robustly the output of $(VC_LIST), so that even
# when $(srcdir) is a pathological name like "....", the leading sed command
# removes only the intended prefix.
_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
55
_dot_escaped_builddir = $(subst .,\.,$(builddir))
56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130

# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
# when $(srcdir) is not ".".
ifeq ($(srcdir),.)
  _prepend_srcdir_prefix =
else
  _prepend_srcdir_prefix = | $(SED) 's|^|$(srcdir)/|'
endif

# In order to be able to consistently filter "."-relative names,
# (i.e., with no $(srcdir) prefix), this definition is careful to
# remove any $(srcdir) prefix, and to restore what it removes.
_sc_excl = \
  $(or $(exclude_file_name_regexp--$@),^$$)
VC_LIST_EXCEPT = \
  $(VC_LIST) | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
	| if test -f $(srcdir)/.x-$@; then $(GREP) -vEf $(srcdir)/.x-$@; \
	  else $(GREP) -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
	| $(GREP) -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
	$(_prepend_srcdir_prefix)

# Override this in syntax-check.mk if you are using a different format in your
# NEWS file.
today = $(shell date +%Y-%m-%d)

# Prevent programs like 'sort' from considering distinct strings to be equal.
# Doing it here saves us from having to set LC_ALL elsewhere in this file.
export LC_ALL = C

## --------------- ##
## Sanity checks.  ##
## --------------- ##

_cfg_mk := $(wildcard $(srcdir)/$(_build-aux)/syntax-check.mk)

# Collect the names of rules starting with 'sc_'.
syntax-check-rules := $(sort $(shell $(SED) -n \
   's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME) $(_cfg_mk)))
.PHONY: $(syntax-check-rules)

ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
  local-checks-available += $(syntax-check-rules)
else
  local-checks-available += no-vc-detected
no-vc-detected:
	@echo "No version control files detected; skipping syntax check"
endif
.PHONY: $(local-checks-available)

# Arrange to print the name of each syntax-checking rule just before running it.
$(syntax-check-rules): %: %.m
sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
.PHONY: $(sc_m_rules_)
$(sc_m_rules_):
	@echo $(patsubst sc_%.m, %, $@)
	@date +%s.%N > .sc-start-$(basename $@)

# Compute and print the elapsed time for each syntax-check rule.
sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
.PHONY: $(sc_z_rules_)
$(sc_z_rules_): %.z: %
	@end=$$(date +%s.%N);						\
	start=$$(cat .sc-start-$*);					\
	rm -f .sc-start-$*;						\
	$(AWK) -v s=$$start -v e=$$end					\
	  'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null

# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
# that computes and prints elapsed time.
local-check :=								\
  $(patsubst sc_%, sc_%.z,						\
    $(filter-out $(local-checks-to-skip), $(local-checks-available)))

syntax-check: $(local-check)

131
_test_script_regex = \<test-lib\.sh\>
E
Eric Blake 已提交
132

133 134 135 136 137 138 139 140
# Most developers don't run 'make distcheck'.  We want the official
# dist to be secure, but don't want to penalize other developers
# using a distro that has not yet picked up the automake fix.
# FIXME remove this ifeq (making the syntax check unconditional)
# once fixed automake (1.11.6 or 1.12.2+) is more common.
ifeq ($(filter dist%, $(MAKECMDGOALS)), )
local-checks-to-skip +=	sc_vulnerable_makefile_CVE-2012-3386
else
141
distdir: sc_vulnerable_makefile_CVE-2012-3386.z
142 143
endif

144
# Files that should never cause syntax check failures.
145
VC_LIST_ALWAYS_EXCLUDE_REGEX = \
146
  (^(docs/(news(-[0-9]*)?\.html\.in|.*\.patch))|\.(po|fig|gif|ico|png))$$
147 148

# Functions like free() that are no-ops on NULL arguments.
149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228
useless_free_options = \
  --name=VBOX_UTF16_FREE \
  --name=VBOX_UTF8_FREE \
  --name=VBOX_COM_UNALLOC_MEM \
  --name=VIR_FREE \
  --name=qemuCapsFree \
  --name=qemuMigrationCookieFree \
  --name=qemuMigrationCookieGraphicsFree \
  --name=sexpr_free \
  --name=usbFreeDevice \
  --name=virBandwidthDefFree \
  --name=virBitmapFree \
  --name=virCPUDefFree \
  --name=virCapabilitiesFree \
  --name=virCapabilitiesFreeGuest \
  --name=virCapabilitiesFreeGuestDomain \
  --name=virCapabilitiesFreeGuestFeature \
  --name=virCapabilitiesFreeGuestMachine \
  --name=virCapabilitiesFreeHostNUMACell \
  --name=virCapabilitiesFreeMachines \
  --name=virCgroupFree \
  --name=virCommandFree \
  --name=virConfFreeList \
  --name=virConfFreeValue \
  --name=virDomainActualNetDefFree \
  --name=virDomainChrDefFree \
  --name=virDomainControllerDefFree \
  --name=virDomainDefFree \
  --name=virDomainDeviceDefFree \
  --name=virDomainDiskDefFree \
  --name=virDomainEventCallbackListFree \
  --name=virObjectEventQueueFree \
  --name=virDomainFSDefFree \
  --name=virDomainGraphicsDefFree \
  --name=virDomainHostdevDefFree \
  --name=virDomainInputDefFree \
  --name=virDomainNetDefFree \
  --name=virDomainObjFree \
  --name=virDomainSmartcardDefFree \
  --name=virDomainSnapshotObjFree \
  --name=virDomainSoundDefFree \
  --name=virDomainVideoDefFree \
  --name=virDomainWatchdogDefFree \
  --name=virFileDirectFdFree \
  --name=virHashFree \
  --name=virInterfaceDefFree \
  --name=virInterfaceIpDefFree \
  --name=virInterfaceObjFree \
  --name=virInterfaceProtocolDefFree \
  --name=virJSONValueFree \
  --name=virLastErrFreeData \
  --name=virNetMessageFree \
  --name=virNWFilterDefFree \
  --name=virNWFilterEntryFree \
  --name=virNWFilterHashTableFree \
  --name=virNWFilterIPAddrLearnReqFree \
  --name=virNWFilterIncludeDefFree \
  --name=virNWFilterObjFree \
  --name=virNWFilterRuleDefFree \
  --name=virNWFilterRuleInstFree \
  --name=virNetworkDefFree \
  --name=virNodeDeviceDefFree \
  --name=virNodeDeviceObjFree \
  --name=virObjectUnref \
  --name=virObjectFreeCallback \
  --name=virPCIDeviceFree \
  --name=virSecretDefFree \
  --name=virStorageEncryptionFree \
  --name=virStorageEncryptionSecretFree \
  --name=virStorageFileFreeMetadata \
  --name=virStoragePoolDefFree \
  --name=virStoragePoolObjFree \
  --name=virStoragePoolSourceFree \
  --name=virStorageVolDefFree \
  --name=virThreadPoolFree \
  --name=xmlBufferFree \
  --name=xmlFree \
  --name=xmlFreeDoc \
  --name=xmlFreeNode \
  --name=xmlXPathFreeContext \
229
  --name=xmlXPathFreeObject
230

231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269
# The following template was generated by this command:
# make ID && aid free|grep '^vi'|sed 's/ .*//;s/^/#   /'
# N virBufferFreeAndReset
# y virCPUDefFree
# y virCapabilitiesFree
# y virCapabilitiesFreeGuest
# y virCapabilitiesFreeGuestDomain
# y virCapabilitiesFreeGuestFeature
# y virCapabilitiesFreeGuestMachine
# y virCapabilitiesFreeHostNUMACell
# y virCapabilitiesFreeMachines
# N virCapabilitiesFreeNUMAInfo FIXME
# y virCgroupFree
# N virConfFree               (diagnoses the "error")
# y virConfFreeList
# y virConfFreeValue
# y virDomainChrDefFree
# y virDomainControllerDefFree
# y virDomainDefFree
# y virDomainDeviceDefFree
# y virDomainDiskDefFree
# y virDomainEventCallbackListFree
# y virDomainEventQueueFree
# y virDomainFSDefFree
# n virDomainFree
# n virDomainFreeName (can't fix -- returns int)
# y virDomainGraphicsDefFree
# y virDomainHostdevDefFree
# y virDomainInputDefFree
# y virDomainNetDefFree
# y virDomainObjFree
# n virDomainSnapshotFree (returns int)
# n virDomainSnapshotFreeName (returns int)
# y virDomainSnapshotObjFree
# y virDomainSoundDefFree
# y virDomainVideoDefFree
# y virDomainWatchdogDefFree
# n virDrvNodeGetCellsFreeMemory (returns int)
# n virDrvNodeGetFreeMemory (returns long long)
E
Eric Blake 已提交
270
# n virFree - dereferences param
271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287
# n virFreeError
# n virHashFree (takes 2 args)
# y virInterfaceDefFree
# n virInterfaceFree (returns int)
# n virInterfaceFreeName
# y virInterfaceIpDefFree
# y virInterfaceObjFree
# n virInterfaceObjListFree
# y virInterfaceProtocolDefFree
# y virJSONValueFree
# y virLastErrFreeData
# y virNWFilterDefFree
# y virNWFilterEntryFree
# n virNWFilterFree (returns int)
# y virNWFilterHashTableFree
# y virNWFilterIPAddrLearnReqFree
# y virNWFilterIncludeDefFree
288 289 290
# n virNWFilterFreeName (returns int)
# y virNWFilterObjFree
# n virNWFilterObjListFree FIXME
291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322
# y virNWFilterRuleDefFree
# n virNWFilterRuleFreeInstanceData (typedef)
# y virNWFilterRuleInstFree
# y virNetworkDefFree
# n virNetworkFree (returns int)
# n virNetworkFreeName (returns int)
# n virNodeDevCapsDefFree FIXME
# y virNodeDeviceDefFree
# n virNodeDeviceFree (returns int)
# y virNodeDeviceObjFree
# n virNodeDeviceObjListFree FIXME
# n virNodeGetCellsFreeMemory (returns int)
# n virNodeGetFreeMemory (returns non-void)
# y virSecretDefFree
# n virSecretFree (returns non-void)
# n virSecretFreeName (2 args)
# n virSecurityLabelDefFree FIXME
# n virStorageBackendDiskMakeFreeExtent (returns non-void)
# y virStorageEncryptionFree
# y virStorageEncryptionSecretFree
# n virStorageFreeType (enum)
# y virStoragePoolDefFree
# n virStoragePoolFree (returns non-void)
# n virStoragePoolFreeName (returns non-void)
# y virStoragePoolObjFree
# n virStoragePoolObjListFree FIXME
# y virStoragePoolSourceFree
# y virStorageVolDefFree
# n virStorageVolFree (returns non-void)
# n virStorageVolFreeName (returns non-void)
# n virStreamFree

323 324 325
# Avoid uses of write(2).  Either switch to streams (fwrite), or use
# the safewrite wrapper.
sc_avoid_write:
326 327 328
	@prohibit='\<write *\(' \
	in_vc_files='\.c$$' \
	halt='consider using safewrite instead of write' \
329
	  $(_sc_search_regexp)
330

331 332
# In debug statements, print flags as bitmask and mode_t as octal.
sc_flags_debug:
333 334
	@prohibit='\<mode=%[0-9.]*[diuxo]' \
	halt='use \"0%o\" to debug mode_t values' \
335
	  $(_sc_search_regexp)
336 337
	@prohibit='[Ff]lags=%[0-9.]*l*[dioux]' \
	halt='use \"0x%x\" to debug flag values' \
338 339 340 341 342 343 344 345 346 347 348
	  $(_sc_search_regexp)

# Prefer 'unsigned int flags', along with checks for unknown flags.
# For historical reasons, we are stuck with 'unsigned long flags' in
# migration, so check for those known 4 instances and no more in public
# API.  Also check that no flags are marked unused, and 'unsigned' should
# appear before any declaration of a flags variable (achieved by
# prohibiting the word prior to the type from ending in anything other
# than d).  The existence of long long, and of documentation about
# flags, makes the regex in the third test slightly harder.
sc_flags_usage:
349 350 351 352 353
	@test "$$(cat $(srcdir)/include/libvirt/libvirt-domain.h \
	    $(srcdir)/include/libvirt/virterror.h \
	    $(srcdir)/include/libvirt/libvirt-qemu.h \
	    $(srcdir)/include/libvirt/libvirt-lxc.h \
	    $(srcdir)/include/libvirt/libvirt-admin.h \
E
Eric Blake 已提交
354
	  | $(GREP) -c '\(long\|unsigned\) flags')" != 4 && \
355
	  { echo '$(ME): new API should use "unsigned int flags"' 1>&2; \
356
	    exit 1; } || :
357
	@prohibit=' flags G_GNUC_UNUSED' \
358
	exclude='virSecurityDomainImageLabelFlags' \
359
	halt='flags should be checked with virCheckFlags' \
360
	  $(_sc_search_regexp)
361 362
	@prohibit='^[^@]*([^d] (int|long long)|[^dg] long) flags[;,)]' \
	halt='flags should be unsigned' \
363 364
	  $(_sc_search_regexp)

E
Eric Blake 已提交
365 366
# Avoid functions that should only be called via macro counterparts.
sc_prohibit_internal_functions:
367
	@prohibit='vir(Free|AllocN?|ReallocN|(Insert|Delete)ElementsN|File(Close|Fclose|Fdopen)) *\(' \
368
	halt='use VIR_ macros instead of internal functions' \
E
Eric Blake 已提交
369 370
	  $(_sc_search_regexp)

371 372 373 374 375
sc_prohibit_raw_virclassnew:
	@prohibit='virClassNew *\(' \
	halt='use VIR_CLASS_NEW instead of virClassNew' \
	  $(_sc_search_regexp)

E
Eric Blake 已提交
376 377
# Avoid raw malloc and free, except in documentation comments.
sc_prohibit_raw_allocation:
378 379
	@prohibit='^.[^*].*\<((m|c|re)alloc|free) *\([^)]' \
	halt='use VIR_ macros from viralloc.h instead of malloc/free' \
E
Eric Blake 已提交
380 381
	  $(_sc_search_regexp)

E
Eric Blake 已提交
382 383
# Avoid functions that can lead to double-close bugs.
sc_prohibit_close:
384 385
	@prohibit='([^>.]|^)\<[fp]?close *\(' \
	halt='use VIR_{FORCE_}[F]CLOSE instead of [f]close' \
E
Eric Blake 已提交
386
	  $(_sc_search_regexp)
387 388
	@prohibit='\<fdopen *\(' \
	halt='use VIR_FDOPEN instead of fdopen' \
E
Eric Blake 已提交
389 390
	  $(_sc_search_regexp)

391 392
# Prefer virCommand for all child processes.
sc_prohibit_fork_wrappers:
393 394
	@prohibit='= *\<(fork|popen|system) *\(' \
	halt='use virCommand for child processes' \
395 396
	  $(_sc_search_regexp)

397
# Prefer g_mkostemp_full with O_CLOEXEC.
398
sc_prohibit_mkstemp:
399 400 401 402 403 404 405 406 407
	@prohibit='[^"]\<mko?stemps? *\(' \
	in_vc_files='\.[chx]$$' \
	halt='use g_mkstemp_full with O_CLOEXEC instead of mkstemp' \
	  $(_sc_search_regexp)

sc_prohibit_mkdtemp:
	@prohibit='[^"]\<mkdtemp *\(' \
	in_vc_files='\.[chx]$$' \
	halt='use g_mkdtemp instead of mkdtemp' \
408 409
	  $(_sc_search_regexp)

E
Eric Blake 已提交
410 411 412
# access with X_OK accepts directories, but we can't exec() those.
# access with F_OK or R_OK is okay, though.
sc_prohibit_access_xok:
413
	@prohibit='access(at)? *\(.*X_OK' \
414
	in_vc_files='\.[ch]$$' \
415
	halt='use virFileIsExecutable instead of access(,X_OK)' \
E
Eric Blake 已提交
416 417
	  $(_sc_search_regexp)

E
Eric Blake 已提交
418
# Use STREQLEN or STRPREFIX rather than comparing strncmp == 0, or != 0.
E
Eric Blake 已提交
419
snp_ = strncmp *\(.+\)
E
Eric Blake 已提交
420
sc_prohibit_strncmp:
421 422 423
	@prohibit='! *strncmp *\(|\<$(snp_) *[!=]=|[!=]= *$(snp_)' \
	exclude=':# *define STR(N?EQLEN|PREFIX)\(' \
	halt='use STREQLEN or STRPREFIX instead of strncmp' \
E
Eric Blake 已提交
424
	  $(_sc_search_regexp)
425

E
Eric Blake 已提交
426 427
# strtol and friends are too easy to misuse
sc_prohibit_strtol:
428 429 430
	@prohibit='\bstrto(u?ll?|[ui]max) *\(' \
	exclude='exempt from syntax-check' \
	halt='use virStrToLong_*, not strtol variants' \
E
Eric Blake 已提交
431
	  $(_sc_search_regexp)
432 433 434
	@prohibit='\bstrto[df] *\(' \
	exclude='exempt from syntax-check' \
	halt='use virStrToDouble, not strtod variants' \
E
Eric Blake 已提交
435 436
	  $(_sc_search_regexp)

M
Michal Privoznik 已提交
437 438
# Use g_strdup_printf rather than as'printf since *strp is undefined on error.
# But for plain %s, g_strdup_printf is overkill compared to g_strdup.
439
sc_prohibit_asprintf:
440
	@prohibit='\<v?a[s]printf\>' \
M
Michal Privoznik 已提交
441
	halt='use g_strdup_printf, not asprintf' \
E
Eric Blake 已提交
442
	  $(_sc_search_regexp)
M
Michal Privoznik 已提交
443 444
	@prohibit='g_strdup_printf.*, *"%s",' \
	halt='use g_strdup instead of g_strdup_printf with "%s"' \
445 446
	  $(_sc_search_regexp)

J
Ján Tomko 已提交
447 448 449 450 451 452
sc_prohobit_vsnprintf:
	@prohibit='\<vsnprintf\>' \
	in_vc_files='\.[chx]$$' \
	halt='use g_vsnprintf, not vsnprintf' \
	  $(_sc_search_regexp)

453
sc_prohibit_strdup:
454 455
	@prohibit='\<strn?dup\> *\(' \
	halt='use VIR_STRDUP, not strdup' \
E
Eric Blake 已提交
456
	  $(_sc_search_regexp)
E
Eric Blake 已提交
457

E
Eric Blake 已提交
458 459
# Prefer virSetUIDGID.
sc_prohibit_setuid:
460 461
	@prohibit='\<set(re)?[ug]id\> *\(' \
	halt='use virSetUIDGID, not raw set*id' \
E
Eric Blake 已提交
462 463
	  $(_sc_search_regexp)

464 465
# Don't compare *id_t against raw -1.
sc_prohibit_risky_id_promotion:
466 467
	@prohibit='\b(user|group|[ug]id) *[=!]= *-' \
	halt='cast -1 to ([ug]id_t) before comparing against id' \
468 469
	  $(_sc_search_regexp)

E
Eric Blake 已提交
470
sc_prohibit_sprintf:
471
	@prohibit='\<[s]printf\>' \
472
	in_vc_files='\.[ch]$$' \
473
	halt='use g_snprintf, not sprintf' \
E
Eric Blake 已提交
474
	  $(_sc_search_regexp)
475

476 477 478 479 480
sc_prohibit_snprintf:
	@prohibit='\<snprintf\>' \
	halt='use g_snprintf, not snprintf' \
	  $(_sc_search_regexp)

481
sc_prohibit_readlink:
482 483
	@prohibit='\<readlink *\(' \
	halt='use virFileResolveLink, not readlink' \
E
Eric Blake 已提交
484
	  $(_sc_search_regexp)
485

486
sc_prohibit_gethostname:
487 488
	@prohibit='gethostname *\(' \
	halt='use virGetHostname, not gethostname' \
E
Eric Blake 已提交
489
	  $(_sc_search_regexp)
490

E
Eric Blake 已提交
491
sc_prohibit_readdir:
492 493 494
	@prohibit='\b(read|close|open)dir *\(' \
	exclude='exempt from syntax-check' \
	halt='use virDirOpen, virDirRead and VIR_DIR_CLOSE' \
E
Eric Blake 已提交
495 496
	  $(_sc_search_regexp)

E
Eric Blake 已提交
497
sc_prohibit_gettext_noop:
498 499
	@prohibit='gettext_noop *\(' \
	halt='use N_, not gettext_noop' \
E
Eric Blake 已提交
500
	  $(_sc_search_regexp)
E
Eric Blake 已提交
501

502
sc_prohibit_VIR_ERR_NO_MEMORY:
503 504
	@prohibit='\<VIR_ERR_NO_MEMORY\>' \
	halt='use virReportOOMError, not VIR_ERR_NO_MEMORY' \
E
Eric Blake 已提交
505
	  $(_sc_search_regexp)
506

507
sc_prohibit_PATH_MAX:
508 509
	@prohibit='\<PATH_MAX\>' \
	halt='dynamically allocate paths, do not use PATH_MAX' \
510 511
	  $(_sc_search_regexp)

512
include $(srcdir)/Makefile.nonreentrant
513
sc_prohibit_nonreentrant:
514 515
	@prohibit="\\<(${NON_REENTRANT_RE}) *\\(" \
	halt="use re-entrant functions (usually ending with _r)" \
516
	  $(_sc_search_regexp)
517

518
sc_prohibit_select:
519 520
	@prohibit='\<select *\(' \
	halt='use poll(), not select()' \
521 522
	  $(_sc_search_regexp)

523 524
# Prohibit the inclusion of <ctype.h>.
sc_prohibit_ctype_h:
525
	@prohibit='^# *include  *<ctype\.h>' \
526
	halt='use Glib g_ascii_* function instead of ctype.h' \
527
	  $(_sc_search_regexp)
528

529 530 531 532 533 534 535
# We have our own wrapper for mocking purposes
sc_prohibit_canonicalize_file_name:
	@prohibit='\<canonicalize_file_name\(' \
	exclude='exempt from syntax-check' \
	halt='use virFileCanonicalizePath() instead of canonicalize_file_name()' \
	  $(_sc_search_regexp)

536 537
# Insist on correct types for [pug]id.
sc_correct_id_types:
538
	@prohibit='\<(int|long) *[pug]id\>' \
539
	exclude='exempt from syntax-check' \
540
	halt='use pid_t for pid, uid_t for uid, gid_t for gid' \
541 542
	  $(_sc_search_regexp)

543 544 545
# "const fooPtr a" is the same as "foo * const a", even though it is
# usually desired to have "foo const *a".  It's easier to just prevent
# the confusing mix of typedef vs. const placement.
546
# Also requires that all 'fooPtr' typedefs are actually pointers.
547
sc_forbid_const_pointer_typedef:
548 549
	@prohibit='(^|[^"])const \w*Ptr' \
	halt='"const fooPtr var" does not declare what you meant' \
550
	  $(_sc_search_regexp)
551 552
	@prohibit='typedef [^(]+ [^*]\w*Ptr\b' \
	halt='use correct style and type for Ptr typedefs' \
553
	  $(_sc_search_regexp)
554

555 556
# Forbid sizeof foo or sizeof (foo), require sizeof(foo)
sc_size_of_brackets:
557 558
	@prohibit='sizeof\s' \
	halt='use sizeof(foo), not sizeof (foo) or sizeof foo' \
559 560
	  $(_sc_search_regexp)

E
Eric Blake 已提交
561
# Ensure that no C source file, docs, or rng schema uses TABs for
562
# indentation.  Also match *.h.in files, to get libvirt.h.in.
563
space_indent_files=(\.(aug(\.in)?|rng|s?[ch](\.in)?|html.in|py|pl|syms)|tools/.*\.in)
564
sc_TAB_in_indentation:
565 566
	@prohibit='^ *	' \
	in_vc_files='$(space_indent_files)$$' \
567
	halt='indent with space, not TAB, in C, sh, html, py, syms and RNG schemas' \
568
	  $(_sc_search_regexp)
569 570 571 572 573

ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper

sc_avoid_ctype_macros:
574
	@prohibit='\b($(ctype_re)) *\(' \
575
	in_vc_files='\.[ch]$$' \
576
	halt='use Glib g_ascii_ macros instead of ctype macros' \
577
	  $(_sc_search_regexp)
578

579
sc_avoid_strcase:
580
	@prohibit='\bstrn?case(cmp|str) *\(' \
581
	halt='use GLib strcase functions instead of raw strcase functions' \
582 583
	  $(_sc_search_regexp)

584
sc_prohibit_virBufferAdd_with_string_literal:
585
	@prohibit='\<virBufferAdd *\([^,]+, *"[^"]' \
E
Eric Blake 已提交
586 587
	halt='use virBufferAddLit, not virBufferAdd, with a string literal' \
	  $(_sc_search_regexp)
588

589
sc_prohibit_virBufferAsprintf_with_string_literal:
590
	@prohibit='\<virBufferAsprintf *\([^,]+, *"([^%"\]|\\.|%%)*"\)' \
591 592 593
	halt='use virBufferAddLit, not virBufferAsprintf, with a string literal' \
	  $(_sc_search_regexp)

594
sc_forbid_manual_xml_indent:
595
	@prohibit='virBuffer.*" +<' \
596 597 598
	halt='use virBufferAdjustIndent instead of spaces when indenting xml' \
	  $(_sc_search_regexp)

599 600
# dirname and basename from <libgen.h> are not required to be thread-safe
sc_prohibit_libgen:
601
	@prohibit='( (base|dir)name *\(|include .libgen\.h)' \
602
	halt='use functions from GLib, not <libgen.h>' \
603 604
	  $(_sc_search_regexp)

605 606
# raw xmlGetProp requires some nasty casts
sc_prohibit_xmlGetProp:
607 608
	@prohibit='\<xmlGetProp *\(' \
	halt='use virXMLPropString, not xmlGetProp' \
609 610
	  $(_sc_search_regexp)

M
Martin Kletzander 已提交
611 612
# xml(ParseURI|SaveUri) doesn't handle IPv6 URIs well
sc_prohibit_xmlURI:
613 614
	@prohibit='\<xml(ParseURI|SaveUri) *\(' \
	halt='use virURI(Parse|Format), not xml(ParseURI|SaveUri)' \
M
Martin Kletzander 已提交
615 616
	  $(_sc_search_regexp)

617 618
# we don't want old old-style return with parentheses around argument
sc_prohibit_return_as_function:
619 620
	@prohibit='\<return *\(([^()]*(\([^()]*\)[^()]*)*)\) *;' \
	halt='avoid extra () with return statements' \
621 622
	  $(_sc_search_regexp)

623
# G_GNUC_UNUSED should only be applied in implementations, not
624
# header declarations
625 626
sc_avoid_g_gnuc_unused_in_header:
	@prohibit='^[^#]*G_GNUC_UNUSED([^:]|$$)' \
627
	in_vc_files='\.h$$' \
628
	halt='use G_GNUC_UNUSED in .c rather than .h files' \
629 630
	  $(_sc_search_regexp)

631
sc_prohibit_attribute_macros:
632
	@prohibit='ATTRIBUTE_(UNUSED|NORETURN|SENTINEL|RETURN_CHECK|NOINLINE|FMT_PRINTF|FALLTHROUGH)' \
633
	in_vc_files='\.[ch]$$' \
634
	halt='use GLib macros: G_GNUC_<ATTRIBUTE_SUFFIX> for most' \
635 636
	  $(_sc_search_regexp)

637 638 639 640 641 642
sc_prohibit_non_glib_macros:
	@prohibit='ARRAY_CARDINALITY' \
	in_vc_files='\.[ch]$$' \
	halt='use GLib macros: G_N_ELEMENTS' \
	  $(_sc_search_regexp)

643
sc_prohibit_int_index:
644 645
	@prohibit='\<(int|unsigned)\s*\*?index\>(\s|,|;)' \
	halt='use different name than 'index' for declaration' \
646 647
	  $(_sc_search_regexp)

648
sc_prohibit_int_ijk:
649 650 651
	@prohibit='\<(int|unsigned) ([^(=]* )*(i|j|k)\>(\s|,|;)' \
	exclude='exempt from syntax-check' \
	halt='use size_t, not int/unsigned int for loop vars i, j, k' \
652 653 654
	  $(_sc_search_regexp)

sc_prohibit_loop_iijjkk:
655 656
	@prohibit='\<(int|unsigned) ([^=]+ )*(ii|jj|kk)\>(\s|,|;)' \
	halt='use i, j, k for loop iterators, not ii, jj, kk' \
657 658
	  $(_sc_search_regexp)

E
Eric Blake 已提交
659 660
# RHEL 5 gcc can't grok "for (int i..."
sc_prohibit_loop_var_decl:
661 662 663
	@prohibit='\<for *\(\w+[ *]+\w+' \
	in_vc_files='\.[ch]$$' \
	halt='declare loop iterators outside the for statement' \
E
Eric Blake 已提交
664
	  $(_sc_search_regexp)
E
Eric Blake 已提交
665 666 667

# Use 'bool', not 'int', when assigning true or false
sc_prohibit_int_assign_bool:
668 669
	@prohibit='\<int\>.*= *(true|false)' \
	halt='use bool type for boolean values' \
E
Eric Blake 已提交
670
	  $(_sc_search_regexp)
671

M
Michal Privoznik 已提交
672
sc_prohibit_unsigned_pid:
673 674
	@prohibit='\<unsigned\> [^,=;(]+pid' \
	halt='use signed type for pid values' \
M
Michal Privoznik 已提交
675 676
	  $(_sc_search_regexp)

677 678 679 680 681 682
# Many of the function names below came from this filter:
# git grep -B2 '\<_('|grep -E '\.c- *[[:alpha:]_][[:alnum:]_]* ?\(.*[,;]$' \
# |sed 's/.*\.c-  *//'|perl -pe 's/ ?\(.*//'|sort -u \
# |grep -vE '^(qsort|if|close|assert|fputc|free|N_|vir.*GetName|.*Unlock|virNodeListDevices|virHashRemoveEntry|freeaddrinfo|.*[fF]ree|xdrmem_create|xmlXPathFreeObject|virUUIDFormat|openvzSetProgramSentinal|polkit_action_unref)$'

msg_gen_function =
683
msg_gen_function += VIR_ERROR
684 685
msg_gen_function += lxcError
msg_gen_function += regerror
686 687
msg_gen_function += vah_error
msg_gen_function += vah_warning
688
msg_gen_function += virGenericReportError
689
msg_gen_function += virRaiseError
690
msg_gen_function += virReportError
691 692
msg_gen_function += virReportErrorHelper
msg_gen_function += virReportSystemError
693
msg_gen_function += virLastErrorPrefixMessage
694 695 696 697 698 699 700 701 702

# Uncomment the following and run "make syntax-check" to see diagnostics
# that are not yet marked for translation, but that need to be rewritten
# so that they are translatable.
# msg_gen_function += fprintf
# msg_gen_function += testError
# msg_gen_function += vshPrint
# msg_gen_function += vshError

J
Ján Tomko 已提交
703 704 705
space =
space +=
func_re= ($(subst $(space),|,$(msg_gen_function)))
706 707 708 709 710 711 712

# Look for diagnostics that aren't marked for translation.
# This won't find any for which error's format string is on a separate line.
# The sed filters eliminate false-positives like these:
#    _("...: "
#    "%s", _("no storage vol w..."
sc_libvirt_unmarked_diagnostics:
713 714 715
	@prohibit='\<$(func_re) *\([^"]*"[^"]*[a-z]{3}' \
	exclude='_\(' \
	halt='found unmarked diagnostic(s)' \
E
Eric Blake 已提交
716
	  $(_sc_search_regexp)
717 718 719 720
	@{ $(VC_LIST_EXCEPT) | xargs \
		$(GREP)     -nE '\<$(func_re) *\(.*;$$' /dev/null; \
	   $(VC_LIST_EXCEPT) | xargs \
		$(GREP) -A1 -nE '\<$(func_re) *\(.*,$$' /dev/null; } \
721 722
	   | $(SED) -E 's/_\("([^\"]|\\.)+"//;s/"%s"//' \
	   | $(GREP) '"' && \
723
	  { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
724
	    exit 1; } || :
725

726 727 728 729 730 731 732 733
# Like the above, but prohibit a newline at the end of a diagnostic.
# This is subject to false positives partly because it naively looks for
# `\n"', which may not be the end of the string, and also because it takes
# two lines of context (the -A2) after the line with the function name.
# FIXME: this rule might benefit from a separate function list, in case
# there are functions to which this one applies but that do not get marked
# diagnostics.
sc_prohibit_newline_at_end_of_diagnostic:
734 735
	@$(VC_LIST_EXCEPT) | xargs $(GREP) -A2 -nE \
	    '\<$(func_re) *\(' /dev/null \
E
Eric Blake 已提交
736
	    | $(GREP) '\\n"' \
737
	  && { echo '$(ME): newline at end of message(s)' 1>&2; \
738 739
	    exit 1; } || :

740 741 742 743
# Look for diagnostics that lack a % in the format string, except that we
# allow VIR_ERROR to do this, and ignore functions that take a single
# string rather than a format argument.
sc_prohibit_diagnostic_without_format:
744 745 746 747
	@{ $(VC_LIST_EXCEPT) | xargs \
		$(GREP)     -nE '\<$(func_re) *\(.*;$$' /dev/null; \
	   $(VC_LIST_EXCEPT) | xargs \
		$(GREP) -A2 -nE '\<$(func_re) *\(.*,$$' /dev/null; } \
748
	   | $(SED) -rn -e ':l; /[,"]$$/ {N;b l;}' \
J
Jim Fehlig 已提交
749
		-e '/(vah_(error|warning))/d' \
750
		-e '/\<$(func_re) *\([^"]*"([^%"]|"\n[^"]*")*"[,)]/p' \
E
Eric Blake 已提交
751
           | $(GREP) -vE 'VIR_ERROR' && \
752
	  { echo '$(ME): found diagnostic without %' 1>&2; \
753 754
	    exit 1; } || :

755
# The strings "" and "%s" should never be marked for translation.
756
# Files under tests/ and examples/ should not be translated.
757
sc_prohibit_useless_translation:
758 759
	@prohibit='_\("(%s)?"\)' \
	halt='found useless translation' \
760
	  $(_sc_search_regexp)
761 762 763
	@prohibit='\<N?_ *\(' \
	in_vc_files='(tests|examples)/' \
	halt='no translations in tests or examples' \
764 765
	  $(_sc_search_regexp)

766 767 768
# When splitting a diagnostic across lines, ensure that there is a space
# or \n on one side of the split.
sc_require_whitespace_in_translation:
769
	@$(VC_LIST_EXCEPT) | xargs $(GREP) -n -A1 '"$$' /dev/null \
770
	   | $(SED) -ne ':l; /"$$/ {N;b l;}; s/"\n[^"]*"/""/g; s/\\n/ /g' \
E
Eric Blake 已提交
771
		-e '/_(.*[^\ ]""[^\ ]/p' | $(GREP) . && \
772
	  { echo '$(ME): missing whitespace at line split' 1>&2; \
773 774
	    exit 1; } || :

775 776
# Enforce recommended preprocessor indentation style.
sc_preprocessor_indentation:
777
	@if cppi --version >/dev/null 2>&1; then \
E
Eric Blake 已提交
778
	  $(VC_LIST_EXCEPT) | $(GREP) -E '\.[ch](\.in)?$$' | xargs cppi -a -c \
779 780 781 782
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2; \
		exit 1; }; \
	else \
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2; \
783 784
	fi

785 786 787
# Enforce similar spec file indentation style, by running cppi on a
# (comment-only) C file that mirrors the same layout as the spec file.
sc_spec_indentation:
788
	@if cppi --version >/dev/null 2>&1; then \
E
Eric Blake 已提交
789
	  for f in $$($(VC_LIST_EXCEPT) | $(GREP) '\.spec\.in$$'); do \
790 791 792 793 794
	    $(SED) -e 's|#|// #|; s|%ifn*\(arch\)* |#if a // |' \
		-e 's/%\(else\|endif\|define\)/#\1/' \
		-e 's/^\( *\)\1\1\1#/#\1/' \
		-e 's|^\( *[^#/ ]\)|// \1|; s|^\( */[^/]\)|// \1|' $$f \
	    | cppi -a -c 2>&1 | $(SED) "s|standard input|$$f|"; \
E
Eric Blake 已提交
795
	  done | { if $(GREP) . >&2; then false; else :; fi; } \
796 797 798 799
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2; \
		exit 1; }; \
	else \
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2; \
800 801
	fi

802 803 804
# Nested conditionals are easier to understand if we enforce that endifs
# can be paired back to the if
sc_makefile_conditionals:
805 806 807
	@prohibit='(else|endif)($$| *#)' \
	in_vc_files='Makefile\.am' \
	halt='match "if FOO" with "endif FOO" in Makefiles' \
808 809
	  $(_sc_search_regexp)

E
Eric Blake 已提交
810 811 812 813
# Long lines can be harder to diff; too long, and git send-email chokes.
# For now, only enforce line length on files where we have intentionally
# fixed things and don't want to regress.
sc_prohibit_long_lines:
814 815 816
	@prohibit='.{90}' \
	in_vc_files='\.arg[sv]' \
	halt='Wrap long lines in expected output files' \
E
Eric Blake 已提交
817
	  $(_sc_search_regexp)
818
	@prohibit='.{80}' \
819
	in_vc_files='Makefile(\.inc)?\.am' \
820
	halt='Wrap long lines in Makefiles' \
821
	  $(_sc_search_regexp)
E
Eric Blake 已提交
822

823
sc_copyright_format:
824 825 826
	@require='Copyright .*Red 'Hat', Inc\.' \
	containing='Copyright .*Red 'Hat \
	halt='Red Hat copyright is missing Inc.' \
827
	  $(_sc_search_regexp)
828 829
	@prohibit='Copyright [^(].*Red 'Hat \
	halt='consistently use (C) in Red Hat copyright' \
830
	  $(_sc_search_regexp)
831 832
	@prohibit='\<RedHat\>' \
	halt='spell Red Hat as two words' \
E
Eric Blake 已提交
833
	  $(_sc_search_regexp)
834

835
# Prefer the new URL listing over the old street address listing when
836 837 838 839 840 841
# calling out where to get a copy of the [L]GPL.  Also, while we have
# to ship COPYING (GPL) alongside COPYING.LESSER (LGPL), we want any
# source file that calls out a top-level file to call out the LGPL
# version.  Note that our typical copyright boilerplate refers to the
# license by name, not by reference to a top-level file.
sc_copyright_usage:
842 843
	@prohibit=Boston,' MA' \
	halt='Point to <http://www.gnu.org/licenses/>, not an address' \
844
	  $(_sc_search_regexp)
845 846 847
	@require='COPYING\.LESSER' \
	containing='COPYING' \
	halt='Refer to COPYING.LESSER for LGPL' \
848
	  $(_sc_search_regexp)
849 850
	@prohibit='COPYING\.LIB' \
	halt='Refer to COPYING.LESSER for LGPL' \
851
	  $(_sc_search_regexp)
852

853 854 855
# Some functions/macros produce messages intended solely for developers
# and maintainers.  Do not mark them for translation.
sc_prohibit_gettext_markup:
856 857
	@prohibit='\<VIR_(WARN|INFO|DEBUG) *\(_\(' \
	halt='do not mark these strings for translation' \
858
	  $(_sc_search_regexp)
859

E
Eric Blake 已提交
860 861 862 863
# Our code is divided into modular subdirectories for a reason, and
# lower-level code must not include higher-level headers.
cross_dirs=$(patsubst $(srcdir)/src/%.,%,$(wildcard $(srcdir)/src/*/.))
cross_dirs_re=($(subst / ,/|,$(cross_dirs)))
864
mid_dirs=access|admin|conf|cpu|locking|logging|rpc|security
E
Eric Blake 已提交
865
sc_prohibit_cross_inclusion:
866 867 868 869
	@for dir in $(cross_dirs); do \
	  case $$dir in \
	    util/) safe="util";; \
	    access/ | conf/) safe="($$dir|conf|util)";; \
870
	    cpu/| network/| node_device/| rpc/| security/| storage/) \
871 872 873 874 875 876 877 878
	      safe="($$dir|util|conf|storage)";; \
	    *) safe="($$dir|$(mid_dirs)|util)";; \
	  esac; \
	  in_vc_files="^src/$$dir" \
	  prohibit='^# *include .$(cross_dirs_re)' \
	  exclude="# *include .$$safe" \
	  halt='unsafe cross-directory include' \
	    $(_sc_search_regexp) \
E
Eric Blake 已提交
879 880
	done

E
Eric Blake 已提交
881 882 883
# When converting an enum to a string, make sure that we track any new
# elements added to the enum by using a _LAST marker.
sc_require_enum_last_marker:
884 885
	@$(VC_LIST_EXCEPT) | xargs \
		$(GREP) -A1 -nE '^[^#]*VIR_ENUM_IMPL *\(' /dev/null \
886 887
	   | $(SED) -ne '/VIR_ENUM_IMPL.*,$$/N' \
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]*,[^,]*[^_,][^L,][^A,][^S,][^T,],/p' \
888
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]\{0,4\},/p' \
E
Eric Blake 已提交
889
	   | $(GREP) . && \
890
	  { echo '$(ME): enum impl needs _LAST marker on second line' 1>&2; \
E
Eric Blake 已提交
891 892
	    exit 1; } || :

893 894 895 896 897 898 899 900 901 902 903
# We're intentionally ignoring a few warnings
#
# E501: Force breaking lines at < 80 characters results in
# some really unnatural code formatting which harms
# readability.
#
# W504: Knuth code style requires the operators "or" and "and" etc
# to be at the start of line in a multi-line conditional.
# This the opposite to what is normal libvirt practice.
#
FLAKE8_IGNORE = E501,W504
904

S
Shi Lei 已提交
905 906 907
sc_flake8:
	@if [ -n "$(FLAKE8)" ]; then \
		$(VC_LIST_EXCEPT) | $(GREP) '\.py$$' | xargs \
908
			$(FLAKE8) --ignore $(FLAKE8_IGNORE) --show-source; \
S
Shi Lei 已提交
909 910 911
	else \
		echo '$(ME): skipping test $@: flake8 not installed' 1>&2; \
	fi
912

913 914
# mymain() in test files should use return, not exit, for nicer output
sc_prohibit_exit_in_tests:
915 916 917
	@prohibit='\<exit *\(' \
	in_vc_files='tests/.*\.c$$' \
	halt='use return, not exit(), in tests' \
918 919
	  $(_sc_search_regexp)

920
# Don't include "libvirt/*.h" in "" form.
921
sc_prohibit_include_public_headers_quote:
922 923 924
	@prohibit='# *include *"libvirt/.*\.h"' \
	in_vc_files='\.[ch]$$' \
	halt='Do not include libvirt/*.h in internal source' \
925 926 927 928 929
	  $(_sc_search_regexp)

# Don't include "libvirt/*.h" in <> form. Except for external tools,
# e.g. Python binding, examples and tools subdirectories.
sc_prohibit_include_public_headers_brackets:
930 931 932
	@prohibit='# *include *<libvirt/.*\.h>' \
	in_vc_files='\.[ch]$$' \
	halt='Do not include libvirt/*.h in internal source' \
933 934
	  $(_sc_search_regexp)

935 936 937
# <config.h> is only needed in .c files; .h files do not need it since
# .c files must include config.h before any other .h.
sc_prohibit_config_h_in_headers:
938 939 940
	@prohibit='^# *include\>.*config\.h' \
	in_vc_files='\.h$$' \
	halt='headers should not include <config.h>' \
941 942
	  $(_sc_search_regexp)

943
sc_prohibit_unbounded_arrays_in_rpc:
944 945 946
	@prohibit='<>' \
	in_vc_files='\.x$$' \
	halt='Arrays in XDR must have a upper limit set for <NNN>' \
947 948
	  $(_sc_search_regexp)

P
Peter Krempa 已提交
949
sc_prohibit_atoi:
950
	@prohibit='\bato(i|f|l|ll|q) *\(' \
P
Peter Krempa 已提交
951 952 953
	halt='Use virStrToLong* instead of atoi, atol, atof, atoq, atoll' \
	  $(_sc_search_regexp)

954
sc_prohibit_wrong_filename_in_comment:
955
	@$(VC_LIST_EXCEPT) | $(GREP) '\.[ch]$$'	| xargs awk 'BEGIN { \
956 957
	  fail=0; \
	} FNR < 3 { \
958
	  n=match($$0, /[[:space:]][^[:space:]]*[.][ch][[:space:]:]/); \
959 960 961 962 963 964 965 966 967 968 969 970
	  if (n > 0) { \
	    A=substr($$0, RSTART+1, RLENGTH-2); \
	    n=split(FILENAME, arr, "/"); \
	    if (A != arr[n]) { \
	      print "in " FILENAME ": " A " mentioned in comments "; \
	      fail=1; \
	    } \
	  } \
	} END { \
	  if (fail == 1) { \
	    exit 1; \
	  } \
971 972
	}' || { echo '$(ME): The file name in comments must match the' \
	    'actual file name' 1>&2; exit 1; }
973

974
sc_prohibit_virConnectOpen_in_virsh:
975 976 977
	@prohibit='\bvirConnectOpen[a-zA-Z]* *\(' \
	in_vc_files='tools/virsh-.*\.[ch]$$' \
	halt='Use vshConnect() in virsh instead of virConnectOpen*' \
978 979
	  $(_sc_search_regexp)

J
Ján Tomko 已提交
980
sc_require_space_before_label:
981 982 983
	@prohibit='^(   ?)?[_a-zA-Z0-9]+:$$' \
	in_vc_files='\.[ch]$$' \
	halt='Top-level labels should be indented by one space' \
J
Ján Tomko 已提交
984 985
	  $(_sc_search_regexp)

986 987 988 989
# Allow for up to three spaces before the label: this is to avoid running
# into situations where neither this rule nor require_space_before_label
# would apply, eg. a line matching ^[a-zA-Z0-9]+ :$
sc_prohibit_space_in_label:
990 991 992
	@prohibit='^ {0,3}[_a-zA-Z0-9]+ +:$$' \
	in_vc_files='\.[ch]$$' \
	halt='There should be no space between label name and colon' \
993 994
	  $(_sc_search_regexp)

995 996
# Doesn't catch all cases of mismatched braces across if-else, but it helps
sc_require_if_else_matching_braces:
997 998 999
	@prohibit='(  else( if .*\))? {|} else( if .*\))?$$)' \
	in_vc_files='\.[chx]$$' \
	halt='if one side of if-else uses {}, both sides must use it' \
1000 1001
	  $(_sc_search_regexp)

1002
sc_curly_braces_style:
1003
	@if $(VC_LIST_EXCEPT) | $(GREP) '\.[ch]$$' | xargs $(GREP) -nHP \
1004
'^\s*(?!([a-zA-Z_]*for_?each[a-zA-Z_]*) ?\()([_a-zA-Z0-9]+( [_a-zA-Z0-9]+)* ?\()?(\*?[_a-zA-Z0-9]+(,? \*?[_a-zA-Z0-9\[\]]+)+|void)\) ?\{' \
1005
	/dev/null; then \
1006 1007 1008
	  echo '$(ME): Non-K&R style used for curly braces around' \
	    'function body' 1>&2; exit 1; \
	fi; \
1009 1010 1011
	if $(VC_LIST_EXCEPT) | $(GREP) '\.[ch]$$' | xargs \
	    $(GREP) -A1 -En ' ((if|for|while|switch) \(|(else|do)\b)[^{]*$$' \
	    /dev/null | $(GREP) '^[^ ]*- *{'; then \
1012
	  echo '$(ME): Use hanging braces for compound statements' 1>&2; exit 1; \
1013
	fi
P
Peter Krempa 已提交
1014

1015
sc_prohibit_windows_special_chars_in_filename:
1016 1017
	@$(VC_LIST_EXCEPT) | $(GREP) '[:*?"<>|]' && \
	{ echo '$(ME): Windows special chars in filename not allowed' 1>&2; echo exit 1; } || :
1018

1019
sc_prohibit_mixed_case_abbreviations:
1020 1021 1022
	@prohibit='Pci|Usb|Scsi' \
	in_vc_files='\.[ch]$$' \
	halt='Use PCI, USB, SCSI, not Pci, Usb, Scsi' \
1023 1024
	  $(_sc_search_regexp)

1025 1026
# Require #include <locale.h> in all files that call setlocale()
sc_require_locale_h:
1027 1028 1029
	@require='include.*locale\.h' \
	containing='setlocale *(' \
	halt='setlocale() requires <locale.h>' \
1030
	  $(_sc_search_regexp)
1031

1032
sc_prohibit_empty_first_line:
1033
	@$(VC_LIST_EXCEPT) | xargs awk 'BEGIN { fail=0; } \
1034 1035 1036
	FNR == 1 { if ($$0 == "") { print FILENAME ":1:"; fail=1; } } \
	END { if (fail == 1) { \
	  print "$(ME): Prohibited empty first line" > "/dev/stderr"; \
1037
	} exit fail; }'
1038

1039
sc_prohibit_paren_brace:
1040 1041 1042
	@prohibit='\)\{$$' \
	in_vc_files='\.[chx]$$' \
	halt='Put space between closing parenthesis and opening brace' \
1043 1044
	  $(_sc_search_regexp)

1045 1046 1047
# C guarantees that static variables are zero initialized, and some compilers
# waste space by sticking explicit initializers in .data instead of .bss
sc_prohibit_static_zero_init:
1048 1049
	@prohibit='\bstatic\b.*= *(0[^xX0-9]|NULL|false)' \
	in_vc_files='\.[chx](\.in)?$$' \
1050 1051 1052
	halt='static variables do not need explicit zero initialization'\
	  $(_sc_search_regexp)

1053 1054
# FreeBSD exports the "devname" symbol which produces a warning.
sc_prohibit_devname:
1055
	@prohibit='\bdevname\b' \
1056
	exclude='sc_prohibit_devname' \
1057
	halt='avoid using devname as FreeBSD exports the symbol' \
1058 1059
	  $(_sc_search_regexp)

J
Jiri Denemark 已提交
1060 1061 1062 1063 1064
sc_prohibit_system_error_with_vir_err:
	@prohibit='\bvirReportSystemError *\(VIR_ERR_' \
	halt='do not use virReportSystemError with VIR_ERR_* error codes' \
	  $(_sc_search_regexp)

1065 1066 1067 1068
# Rule to prohibit usage of virXXXFree within library, daemon, remote, etc.
# functions. There's a corresponding exclude to allow usage within tests,
# docs, examples, tools, src/libvirt-*.c, and include/libvirt/libvirt-*.h
sc_prohibit_virXXXFree:
1069
	@prohibit='\bvir(Domain|Network|NodeDevice|StorageVol|StoragePool|Stream|Secret|NWFilter|Interface|DomainSnapshot)Free\b' \
1070
	exclude='sc_prohibit_virXXXFree' \
1071
	halt='avoid using virXXXFree, use virObjectUnref instead' \
1072 1073
	  $(_sc_search_regexp)

1074 1075 1076 1077 1078
sc_prohibit_sysconf_pagesize:
	@prohibit='sysconf\(_SC_PAGESIZE' \
	halt='use virGetSystemPageSize[KB] instead of sysconf(_SC_PAGESIZE)' \
	  $(_sc_search_regexp)

1079
sc_prohibit_virSecurity:
1080 1081 1082
	@$(VC_LIST_EXCEPT) | $(GREP) 'src/qemu/' | \
		$(GREP) -v 'src/qemu/qemu_security' | \
		xargs $(GREP) -Pn 'virSecurityManager(?!Ptr)' /dev/null && \
1083 1084
		{ echo '$(ME): prefer qemuSecurity wrappers' 1>&2; exit 1; } || :

J
Jiri Denemark 已提交
1085 1086 1087
sc_prohibit_pthread_create:
	@prohibit='\bpthread_create\b' \
	exclude='sc_prohibit_pthread_create' \
1088
	halt='avoid using pthread_create, use virThreadCreate instead' \
J
Jiri Denemark 已提交
1089 1090
	  $(_sc_search_regexp)

1091
sc_prohibit_not_streq:
1092 1093
	@prohibit='! *STRN?EQ *\(.*\)' \
	halt='Use STRNEQ instead of !STREQ and STREQ instead of !STRNEQ' \
1094 1095
	  $(_sc_search_regexp)

J
Ján Tomko 已提交
1096
sc_prohibit_verbose_strcat:
1097 1098
	@prohibit='strncat\([^,]*,\s+([^,]*),\s+strlen\(\1\)\)' \
	in_vc_files='\.[ch]$$' \
J
Ján Tomko 已提交
1099 1100 1101
	halt='Use strcat(a, b) instead of strncat(a, b, strlen(b))' \
	  $(_sc_search_regexp)

1102 1103 1104
# Ensure that each .c file containing a "main" function also
# calls virGettextInitialize
sc_gettext_init:
1105 1106 1107 1108
	@require='virGettextInitialize *\(' \
	in_vc_files='\.c$$' \
	containing='\<main *(' \
	halt='the above files do not call virGettextInitialize' \
1109 1110
	  $(_sc_search_regexp)

1111
sc_prohibit_obj_free_apis_in_virsh:
1112
	@prohibit='\bvir(Domain|DomainSnapshot|Secret)Free\b' \
1113
	in_vc_files='virsh.*\.[ch]$$' \
1114
	exclude='sc_prohibit_obj_free_apis_in_virsh' \
1115
	halt='avoid using virDomain(Snapshot)Free in virsh, use virsh-prefixed wrappers instead' \
1116 1117
	  $(_sc_search_regexp)

1118 1119 1120 1121 1122 1123 1124 1125 1126 1127 1128 1129 1130 1131 1132 1133 1134
https_sites = www.libvirt.org
https_sites += libvirt.org
https_sites += security.libvirt.org
https_sites += qemu.org
https_sites += www.qemu.org
https_sites += wiki.qemu.org
https_sites += linux-kvm.org
https_sites += www.linux-kvm.org

https_re= ($(subst $(space),|,$(https_sites)))

sc_prohibit_http_urls:
	@prohibit='http://$(https_re)' \
	exclude="/schemas/" \
	halt='Links must use https:// protocol' \
	  $(_sc_search_regexp)

1135 1136 1137 1138 1139
sc_prohibit_author:
	@prohibit="(\*|#)\s*(A|a)uthors?:" \
	halt="Author: statements are prohibited in source comments" \
	  $(_sc_search_regexp)

1140 1141
# Alignment is usually achieved through spaces (at least two of them)
# or tabs (at least one of them) right before the trailing backslash
1142
sc_prohibit_backslash_alignment:
1143
	@prohibit='(  |	)\\$$' \
1144 1145 1146 1147
	in_vc_files='*\.([chx]|am|mk)$$' \
	halt='Do not attempt to right-align backslashes' \
	  $(_sc_search_regexp)

1148 1149 1150
# Some syntax rules pertaining to the usage of cleanup macros
# implementing GNU C's cleanup attribute

E
Eric Blake 已提交
1151
# Rule to ensure that variables declared using a cleanup macro are
1152 1153
# always initialized.
sc_require_attribute_cleanup_initialization:
1154
	@prohibit='((g_auto(ptr|free)?)|(VIR_AUTO((FREE|PTR|UNREF|CLEAN)\(.+\)|CLOSE|STRINGLIST))) *[^=]+;' \
1155 1156 1157 1158
	in_vc_files='\.[chx]$$' \
	halt='variable declared with a cleanup macro must be initialized' \
	  $(_sc_search_regexp)

1159 1160 1161 1162 1163 1164 1165 1166
# "class" in headers is not good because by default Vim treats it as a keyword
# Let's prohibit it in source files as well.
sc_prohibit_class:
	@prohibit=' +_?class *;' \
	in_vc_files='\.[chx]$$' \
	halt='use klass instead of class or _class' \
	  $(_sc_search_regexp)

1167 1168 1169 1170 1171 1172 1173 1174 1175 1176 1177 1178 1179
# The dirent "d_type" field is non-portable and even when it
# exists some filesystems will only ever return DT_UNKNOWN.
# This field should only be used by code which is exclusively
# run platforms supporting "d_type" and must expect DT_UNKNOWN.
# We blacklist it to discourage accidental usage which has
# happened many times. Add an exclude rule if it is genuinely
# needed and the above restrictions are acceptable.
sc_prohibit_dirent_d_type:
	@prohibit='(->|\.)d_type' \
	in_vc_files='\.[chx]$$' \
	halt='do not use the d_type field in "struct dirent"' \
	  $(_sc_search_regexp)

1180

1181 1182 1183 1184 1185 1186 1187 1188 1189 1190 1191 1192 1193 1194 1195 1196 1197 1198 1199 1200 1201 1202 1203 1204 1205 1206 1207 1208 1209 1210 1211 1212 1213 1214 1215 1216 1217 1218 1219 1220 1221 1222 1223 1224 1225 1226 1227 1228 1229 1230 1231 1232 1233 1234 1235 1236 1237 1238 1239 1240 1241 1242 1243 1244 1245 1246 1247 1248 1249 1250 1251 1252 1253 1254 1255 1256 1257 1258 1259 1260 1261 1262 1263 1264 1265 1266 1267 1268 1269 1270 1271 1272 1273 1274 1275 1276 1277 1278 1279 1280 1281 1282 1283 1284 1285 1286 1287 1288 1289 1290 1291 1292 1293 1294 1295 1296 1297 1298 1299 1300 1301 1302 1303 1304 1305 1306 1307 1308 1309 1310 1311 1312 1313 1314 1315 1316 1317 1318 1319 1320 1321 1322 1323 1324 1325 1326 1327 1328 1329 1330 1331 1332 1333 1334 1335 1336 1337 1338 1339 1340 1341 1342 1343 1344 1345 1346 1347 1348 1349 1350 1351 1352 1353 1354 1355 1356 1357 1358 1359 1360 1361 1362 1363 1364 1365 1366 1367 1368 1369 1370 1371 1372 1373 1374 1375 1376 1377 1378 1379 1380 1381 1382 1383 1384 1385 1386 1387 1388 1389 1390 1391 1392 1393 1394 1395 1396 1397 1398 1399 1400 1401 1402 1403 1404 1405 1406 1407 1408 1409 1410 1411 1412 1413 1414 1415 1416 1417 1418 1419 1420 1421 1422 1423 1424 1425 1426 1427 1428 1429 1430 1431 1432 1433 1434 1435 1436 1437 1438 1439 1440 1441 1442 1443 1444 1445 1446 1447 1448 1449 1450 1451 1452 1453 1454 1455 1456 1457 1458 1459 1460 1461 1462 1463 1464 1465 1466 1467 1468 1469 1470 1471 1472 1473 1474 1475 1476 1477 1478 1479 1480 1481 1482 1483 1484 1485 1486 1487 1488 1489 1490 1491 1492 1493 1494 1495 1496 1497 1498 1499 1500 1501 1502 1503 1504 1505 1506 1507 1508 1509 1510 1511 1512 1513 1514 1515 1516 1517 1518 1519 1520 1521 1522 1523 1524 1525 1526 1527 1528 1529 1530 1531 1532 1533 1534 1535 1536 1537 1538 1539 1540 1541 1542 1543 1544 1545 1546 1547 1548 1549 1550 1551 1552 1553 1554 1555 1556 1557 1558 1559 1560 1561 1562 1563 1564 1565 1566 1567 1568 1569 1570 1571 1572 1573 1574 1575 1576 1577 1578 1579 1580 1581 1582 1583 1584 1585 1586 1587 1588 1589 1590 1591 1592 1593 1594 1595 1596 1597 1598 1599 1600 1601 1602 1603 1604 1605 1606 1607 1608 1609 1610 1611 1612 1613 1614 1615 1616 1617 1618 1619 1620 1621 1622 1623 1624 1625 1626 1627 1628 1629 1630 1631 1632 1633 1634 1635 1636 1637 1638 1639 1640 1641 1642 1643 1644 1645 1646 1647 1648 1649 1650 1651 1652 1653 1654 1655 1656 1657 1658 1659 1660 1661 1662 1663 1664 1665 1666 1667 1668 1669 1670 1671 1672 1673 1674 1675 1676 1677 1678 1679 1680 1681 1682 1683 1684 1685 1686 1687 1688 1689 1690 1691 1692 1693 1694 1695 1696 1697 1698 1699 1700 1701 1702 1703 1704 1705 1706 1707 1708 1709 1710 1711 1712 1713 1714 1715 1716 1717 1718 1719 1720 1721 1722 1723 1724 1725 1726 1727 1728 1729 1730 1731 1732 1733 1734 1735 1736 1737 1738 1739 1740 1741 1742 1743 1744 1745 1746 1747 1748 1749 1750 1751 1752 1753 1754 1755 1756 1757 1758 1759 1760 1761 1762 1763 1764 1765 1766 1767 1768 1769 1770 1771 1772 1773 1774 1775 1776 1777 1778 1779 1780 1781 1782 1783 1784 1785 1786 1787 1788 1789 1790 1791 1792 1793 1794 1795 1796 1797 1798 1799 1800 1801 1802 1803 1804 1805 1806 1807 1808 1809 1810 1811 1812 1813 1814 1815 1816 1817 1818 1819 1820 1821 1822 1823 1824 1825 1826 1827 1828 1829 1830 1831 1832 1833 1834 1835 1836 1837 1838 1839 1840 1841 1842 1843 1844 1845 1846 1847 1848 1849 1850 1851 1852 1853 1854 1855 1856 1857 1858 1859 1860 1861 1862 1863 1864
# _sc_search_regexp
#
# This macro searches for a given construct in the selected files and
# then takes some action.
#
# Parameters (shell variables):
#
#  prohibit | require
#
#     Regular expression (ERE) denoting either a forbidden construct
#     or a required construct.  Those arguments are exclusive.
#
#  exclude
#
#     Regular expression (ERE) denoting lines to ignore that matched
#     a prohibit construct.  For example, this can be used to exclude
#     comments that mention why the nearby code uses an alternative
#     construct instead of the simpler prohibited construct.
#
#  in_vc_files | in_files
#
#     grep-E-style regexp selecting the files to check.  For in_vc_files,
#     the regexp is used to select matching files from the list of all
#     version-controlled files; for in_files, it's from the names printed
#     by "find $(srcdir)".  When neither is specified, use all files that
#     are under version control.
#
#  containing | non_containing
#
#     Select the files (non) containing strings matching this regexp.
#     If both arguments are specified then CONTAINING takes
#     precedence.
#
#  with_grep_options
#
#     Extra options for grep.
#
#  ignore_case
#
#     Ignore case.
#
#  halt
#
#     Message to display before to halting execution.
#
# Finally, you may exempt files based on an ERE matching file names.
# For example, to exempt from the sc_space_tab check all files with the
# .diff suffix, set this Make variable:
#
# exclude_file_name_regexp--sc_space_tab = \.diff$
#
# Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
# when filtering by name via in_files, we explicitly filter out matching
# names here as well.

# Initialize each, so that envvar settings cannot interfere.
export require =
export prohibit =
export exclude =
export in_vc_files =
export in_files =
export containing =
export non_containing =
export halt =
export with_grep_options =

# By default, _sc_search_regexp does not ignore case.
export ignore_case =
_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)

define _sc_say_and_exit
   dummy=; : so we do not need a semicolon before each use;		\
   { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
endef

define _sc_search_regexp
   dummy=; : so we do not need a semicolon before each use;		\
									\
   : Check arguments;							\
   test -n "$$prohibit" && test -n "$$require"				\
     && { msg='Cannot specify both prohibit and require'		\
          $(_sc_say_and_exit) } || :;					\
   test -z "$$prohibit" && test -z "$$require"				\
     && { msg='Should specify either prohibit or require'		\
          $(_sc_say_and_exit) } || :;					\
   test -z "$$prohibit" && test -n "$$exclude"				\
     && { msg='Use of exclude requires a prohibit pattern'		\
          $(_sc_say_and_exit) } || :;					\
   test -n "$$in_vc_files" && test -n "$$in_files"			\
     && { msg='Cannot specify both in_vc_files and in_files'		\
          $(_sc_say_and_exit) } || :;					\
   test "x$$halt" != x							\
     || { msg='halt not defined' $(_sc_say_and_exit) };			\
									\
   : Filter by file name;						\
   if test -n "$$in_files"; then					\
     files=$$(find $(srcdir) | $(GREP) -E "$$in_files"			\
              | $(GREP) -Ev '$(_sc_excl)');				\
   else									\
     files=$$($(VC_LIST_EXCEPT));					\
     if test -n "$$in_vc_files"; then					\
       files=$$(echo "$$files" | $(GREP) -E "$$in_vc_files");		\
     fi;								\
   fi;									\
									\
   : Filter by content;							\
   test -n "$$files"							\
     && test -n "$$containing"						\
     && { files=$$(echo "$$files" | xargs $(GREP) -l "$$containing"); }	\
     || :;								\
   test -n "$$files"							\
     && test -n "$$non_containing"					\
     && { files=$$(echo "$$files" | xargs $(GREP) -vl "$$non_containing"); } \
     || :;								\
									\
   : Check for the construct;						\
   if test -n "$$files"; then						\
     if test -n "$$prohibit"; then					\
       echo "$$files"							\
         | xargs $(GREP) $$with_grep_options $(_ignore_case) -nE	\
		"$$prohibit" /dev/null					\
         | $(GREP) -vE "$${exclude:-^$$}"				\
         && { msg="$$halt" $(_sc_say_and_exit) }			\
         || :;								\
     else								\
       echo "$$files"							\
         | xargs							\
             $(GREP) $$with_grep_options $(_ignore_case) -LE "$$require" \
         | $(GREP) .							\
         && { msg="$$halt" $(_sc_say_and_exit) }			\
         || :;								\
     fi									\
   else :;								\
   fi || :;
endef

sc_avoid_if_before_free:
	@$(VC_LIST_EXCEPT)						\
	  | $(GREP) -v useless-if-before-free				\
	  | xargs							\
	      $(srcdir)/$(_build-aux)/useless-if-before-free		\
	      $(useless_free_options)					\
	  && { printf '$(ME): found useless "if"'			\
		      ' before "free" above\n' 1>&2;			\
	       exit 1; }						\
	  || :

sc_cast_of_argument_to_free:
	@prohibit='\<free *\( *\(' halt="don't cast free argument"	\
	  $(_sc_search_regexp)

sc_cast_of_x_alloc_return_value:
	@prohibit='\*\) *x(m|c|re)alloc\>'				\
	halt="don't cast x*alloc return value"				\
	  $(_sc_search_regexp)

# Use STREQ rather than comparing strcmp == 0, or != 0.
sp_ = strcmp *\(.+\)
sc_prohibit_strcmp:
	@prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)'		\
	exclude='# *define STRN?EQ\('					\
	halt='replace strcmp calls above with STREQ/STRNEQ'		\
	  $(_sc_search_regexp)

# Really.  You don't want to use this function.
# It may fail to NUL-terminate the destination,
# and always NUL-pads out to the specified length.
sc_prohibit_strncpy:
	@prohibit='\<strncpy *\('					\
	halt='do not use strncpy, period'				\
	  $(_sc_search_regexp)

# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
# Convert all uses automatically, via these two commands:
# git grep -l '\<exit *(1)' \
#  | grep -vEf .x-sc_prohibit_magic_number_exit \
#  | xargs --no-run-if-empty \
#      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
# git grep -l '\<exit *(0)' \
#  | grep -vEf .x-sc_prohibit_magic_number_exit \
#  | xargs --no-run-if-empty \
#      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
sc_prohibit_magic_number_exit:
	@prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]'	\
	exclude='exit \(77\)|error ?\(((0|77),|[^,]*)'			\
	halt='use EXIT_* values rather than magic number'		\
	  $(_sc_search_regexp)

# "FATAL:" should be fully upper-cased in error messages
# "WARNING:" should be fully upper-cased, or fully lower-cased
sc_error_message_warn_fatal:
	@$(VC_LIST_EXCEPT)						\
	  | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null		\
	  | $(GREP) -E '"Warning|"Fatal|"fatal'				\
	  && { echo '$(ME): use FATAL, WARNING or warning' 1>&2;	\
	       exit 1; }						\
	  || :

# Error messages should not end with a period
sc_error_message_period:
	@$(VC_LIST_EXCEPT)						\
	  | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null		\
	  | $(GREP) -E '[^."]\."'					\
	  && { echo '$(ME): found error message ending in period' 1>&2;	\
	       exit 1; }						\
	  || :

# Don't use cpp tests of this symbol.  All code assumes config.h is included.
sc_prohibit_have_config_h:
	@prohibit='^# *if.*HAVE''_CONFIG_H'				\
	halt='found use of HAVE''_CONFIG_H; remove'			\
	  $(_sc_search_regexp)

# Nearly all .c files must include <config.h>.  However, we also permit this
# via inclusion of a package-specific header, if syntax-check.mk specified one.
# config_h_header must be suitable for grep -E.
config_h_header ?= <config\.h>
sc_require_config_h:
	@require='^# *include $(config_h_header)'			\
	in_vc_files='\.c$$'						\
	halt='the above files do not include <config.h>'		\
	  $(_sc_search_regexp)

# Print each file name for which the first #include does not match
# $(config_h_header).  Like grep -m 1, this only looks at the first match.
perl_config_h_first_ =							\
  -e 'BEGIN {$$ret = 0}'						\
  -e 'if (/^\# *include\b/) {'						\
  -e '  if (not m{^\# *include $(config_h_header)}) {'			\
  -e '    print "$$ARGV\n";'						\
  -e '    $$ret = 1;'							\
  -e '  }'								\
  -e '  \# Move on to next file after first include'			\
  -e '  close ARGV;'							\
  -e '}'								\
  -e 'END {exit $$ret}'

# You must include <config.h> before including any other header file.
# This can possibly be via a package-specific header, if given by syntax-check.mk.
sc_require_config_h_first:
	@if $(VC_LIST_EXCEPT) | $(GREP) '\.c$$' > /dev/null; then	\
	  files=$$($(VC_LIST_EXCEPT) | $(GREP) '\.c$$') &&		\
	  perl -n $(perl_config_h_first_) $$files ||			\
	    { echo '$(ME): the above files include some other header'	\
		'before <config.h>' 1>&2; exit 1; } || :;		\
	else :;								\
	fi

sc_prohibit_HAVE_MBRTOWC:
	@prohibit='\bHAVE_MBRTOWC\b'					\
	halt="do not use $$prohibit; it is always defined"		\
	  $(_sc_search_regexp)

# To use this "command" macro, you must first define two shell variables:
# h: the header name, with no enclosing <> or ""
# re: a regular expression that matches IFF something provided by $h is used.
define _sc_header_without_use
  dummy=; : so we do not need a semicolon before each use;		\
  h_esc=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`;			\
  if $(VC_LIST_EXCEPT) | $(GREP) '\.c$$' > /dev/null; then		\
    files=$$($(GREP) -l '^# *include '"$$h_esc"				\
	     $$($(VC_LIST_EXCEPT) | $(GREP) '\.c$$')) &&		\
    $(GREP) -LE "$$re" $$files | $(GREP) . &&				\
      { echo "$(ME): the above files include $$h but don't use it"	\
	1>&2; exit 1; } || :;						\
  else :;								\
  fi
endef

# Prohibit the inclusion of assert.h without an actual use of assert.
sc_prohibit_assert_without_use:
	@h='assert.h' re='\<assert *\(' $(_sc_header_without_use)

# Prohibit the inclusion of close-stream.h without an actual use.
sc_prohibit_close_stream_without_use:
	@h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)

# Prohibit the inclusion of getopt.h without an actual use.
sc_prohibit_getopt_without_use:
	@h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)

# Don't include this header unless you use one of its functions.
sc_prohibit_long_options_without_use:
	@h='long-options.h' re='\<parse_(long_options|gnu_standard_options_only) *\(' \
	  $(_sc_header_without_use)

# Don't include this header unless you use one of its functions.
sc_prohibit_inttostr_without_use:
	@h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
	  $(_sc_header_without_use)

# Don't include this header unless you use one of its functions.
sc_prohibit_ignore_value_without_use:
	@h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
	  $(_sc_header_without_use)

# Don't include this header unless you use one of its functions.
sc_prohibit_error_without_use:
	@h='error.h' \
	re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
	  $(_sc_header_without_use)

# Don't include xalloc.h unless you use one of its functions.
# Consider these symbols:
# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
# Divide into two sets on case, and filter each through this:
# | sort | perl -MRegexp::Assemble -le \
#  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
# Note this was produced by the above:
# _xa1 = \
#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
# But we can do better, in at least two ways:
# 1) take advantage of two "dup"-suffixed strings:
# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
# "char|[cmz]"
# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
_xa2 = X([CZ]|N?M)ALLOC
sc_prohibit_xalloc_without_use:
	@h='xalloc.h' \
	re='\<($(_xa1)|$(_xa2)) *\('\
	  $(_sc_header_without_use)

sc_prohibit_cloexec_without_use:
	@h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
	  $(_sc_header_without_use)

sc_prohibit_posixver_without_use:
	@h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)

sc_prohibit_same_without_use:
	@h='same.h' re='\<same_name(at)? *\(' $(_sc_header_without_use)

sc_prohibit_hash_pjw_without_use:
	@h='hash-pjw.h' \
	re='\<hash_pjw\>' \
	  $(_sc_header_without_use)

sc_prohibit_safe_read_without_use:
	@h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
	  $(_sc_header_without_use)

sc_prohibit_argmatch_without_use:
	@h='argmatch.h' \
	re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
	  $(_sc_header_without_use)

sc_prohibit_canonicalize_without_use:
	@h='canonicalize.h' \
	re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
	  $(_sc_header_without_use)

sc_prohibit_root_dev_ino_without_use:
	@h='root-dev-ino.h' \
	re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
	  $(_sc_header_without_use)

sc_prohibit_openat_without_use:
	@h='openat.h' \
	re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>' \
	  $(_sc_header_without_use)

# The following list was generated by running:
# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
#   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
_sig_functions = \
  bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
  sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
  siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
  sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
# The following were extracted from "man signal.h" manually.
_sig_types_and_consts =							\
  MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK		\
  SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL		\
  SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE	\
  SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t	\
  sigstack sigval stack_t ucontext_t
# generated via this:
# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
_sig_names =								\
  SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT	\
  SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL	\
  SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP	\
  SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR	\
  SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS	\
  SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1	\
  SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW	\
  SIGXCPU SIGXFSZ
_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))

# Prohibit the inclusion of signal.h without an actual use.
sc_prohibit_signal_without_use:
	@h='signal.h'							\
	re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'		\
	  $(_sc_header_without_use)

# Don't include stdio--.h unless you use one of its functions.
sc_prohibit_stdio--_without_use:
	@h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('		\
	  $(_sc_header_without_use)

# Don't include stdio-safer.h unless you use one of its functions.
sc_prohibit_stdio-safer_without_use:
	@h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('	\
	  $(_sc_header_without_use)

# Prohibit the inclusion of strings.h without a sensible use.
# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
sc_prohibit_strings_without_use:
	@h='strings.h'							\
	re='\<(strn?casecmp|ffs(ll)?)\>'				\
	  $(_sc_header_without_use)


_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
# Prohibit the inclusion of stddef.h without an actual use.
sc_prohibit_stddef_without_use:
	@h='stddef.h'							\
	re='\<($(_stddef_syms_re))\>'					\
	  $(_sc_header_without_use)

_de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
_de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
_de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
_dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
# Prohibit the inclusion of dirent.h without an actual use.
sc_prohibit_dirent_without_use:
	@h='dirent.h'							\
	re='\<($(_dirent_syms_re))\>'					\
	  $(_sc_header_without_use)

# Don't include xfreopen.h unless you use one of its functions.
sc_prohibit_xfreopen_without_use:
	@h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)

# Ensure that each .c file containing a "main" function also
# calls bindtextdomain.
sc_bindtextdomain:
	@require='bindtextdomain *\('					\
	in_vc_files='\.c$$'						\
	containing='\<main *('						\
	halt='the above files do not call bindtextdomain'		\
	  $(_sc_search_regexp)

sc_trailing_blank:
	@prohibit='[	 ]$$'						\
	halt='found trailing blank(s)'					\
	exclude='^Binary file .* matches$$'				\
	  $(_sc_search_regexp)


# A regexp matching function names like "error" that may be used
# to emit translatable messages.
_gl_translatable_diag_func_re ?= error

# Look for diagnostics that aren't marked for translation.
# This won't find any for which error's format string is on a separate line.
sc_unmarked_diagnostics:
	@prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
	exclude='(_|ngettext ?)\('					\
	halt='found unmarked diagnostic(s)'				\
	  $(_sc_search_regexp)


sc_prohibit_defined_have_decl_tests:
	@prohibit='(#[	 ]*ifn?def|\<defined)\>[	 (]+HAVE_DECL_'	\
	halt='HAVE_DECL macros are always defined'			\
	  $(_sc_search_regexp)

# ==================================================================

# Prohibit checked in backup files.
sc_prohibit_backup_files:
	@$(VC_LIST) | $(GREP) '~$$' &&					\
	  { echo '$(ME): found version controlled backup file' 1>&2;	\
	    exit 1; } || :

# Require the latest GFDL.  Two regexp, since some .texi files end up
# line wrapping between 'Free Documentation License,' and 'Version'.
_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
sc_GFDL_version:
	@prohibit='$(_GFDL_regexp)'					\
	halt='GFDL vN, N!=3'						\
	  $(_sc_search_regexp)

cvs_keywords = \
  Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State

sc_prohibit_cvs_keyword:
	@prohibit='\$$($(cvs_keywords))\$$'				\
	halt='do not use CVS keyword expansion'				\
	  $(_sc_search_regexp)

# This Perl code is slightly obfuscated.  Not only is each "$" doubled
# because it's in a Makefile, but the $$c's are comments;  we cannot
# use "#" due to the way the script ends up concatenated onto one line.
# It would be much more concise, and would produce better output (including
# counts) if written as:
#   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
# but that would be far less efficient, reading the entire contents
# of each file, rather than just the last two bytes of each.
# In addition, while the code below detects both blank lines and a missing
# newline at EOF, the above detects only the former.
#
# This is a perl script that is expected to be the single-quoted argument
# to a command-line "-le".  The remaining arguments are file names.
# Print the name of each file that does not end in exactly one newline byte.
# I.e., warn if there are blank lines (2 or more newlines), or if the
# last byte is not a newline.  However, currently we don't complain
# about any file that contains exactly one byte.
# Exit nonzero if at least one such file is found, otherwise, exit 0.
# Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
#
# Use this if you want to remove trailing empty lines from selected files:
#   perl -pi -0777 -e 's/\n\n+$/\n/' files...
#
require_exactly_one_NL_at_EOF_ =					\
  foreach my $$f (@ARGV)						\
    {									\
      open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;	\
      my $$p = sysseek (F, -2, 2);					\
      my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
      my $$last_two_bytes;						\
      defined $$p and $$p = sysread F, $$last_two_bytes, 2;		\
      close F;								\
      $$c = "ignore read failure";					\
      $$p && ($$last_two_bytes eq "\n\n"				\
              || substr ($$last_two_bytes,1) ne "\n")			\
          and (print $$f), $$fail=1;					\
    }									\
  END { exit defined $$fail }
sc_prohibit_empty_lines_at_EOF:
	@$(VC_LIST_EXCEPT)						\
	  | xargs perl -le '$(require_exactly_one_NL_at_EOF_)'		\
	  || { echo '$(ME): empty line(s) or no newline at EOF' 1>&2;	\
	       exit 1; }						\
	  || :


# Perl block to convert a match to FILE_NAME:LINENO:TEST,
# that is shared by two definitions below.
perl_filename_lineno_text_ =						\
    -e '  {'								\
    -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'				\
    -e '    ($$v = $$&) =~ s/\n/\\n/g;'					\
    -e '    print "$$ARGV:$$n:$$v\n";'					\
    -e '  }'

prohibit_doubled_words_ = \
    the then in an on if is it but for or at and do to
# expand the regex before running the check to avoid using expensive captures
prohibit_doubled_word_expanded_ = \
    $(join $(prohibit_doubled_words_),$(addprefix \s+,$(prohibit_doubled_words_)))
prohibit_doubled_word_RE_ ?= \
    /\b(?:$(subst $(_sp),|,$(prohibit_doubled_word_expanded_)))\b/gims
prohibit_doubled_word_ =						\
    -e 'while ($(prohibit_doubled_word_RE_))'				\
    $(perl_filename_lineno_text_)

# Define this to a regular expression that matches
# any filename:dd:match lines you want to ignore.
# The default is to ignore no matches.
ignore_doubled_word_match_RE_ ?= ^$$

sc_prohibit_doubled_word:
	@$(VC_LIST_EXCEPT)						\
	  | xargs perl -n -0777 $(prohibit_doubled_word_)		\
	  | $(GREP) -vE '$(ignore_doubled_word_match_RE_)'		\
	  | $(GREP) .							\
	  && { echo '$(ME): doubled words' 1>&2; exit 1; }		\
	  || :

# Except for shell files and for loops, double semicolon is probably a mistake
sc_prohibit_double_semicolon:
	@prohibit='; *;[	{} \]*(/[/*]|$$)'			\
	in_vc_files='\.[chly]$$'					\
	exclude='\bfor *\(.*\)'						\
	halt="Double semicolon detected"				\
	  $(_sc_search_regexp)

_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
# Using test's -a and -o operators is not portable.
# We prefer test over [, since the latter is spelled [[ in configure.ac.
sc_prohibit_test_minus_ao:
	@prohibit='(\<test| \[+) .+ -[ao] '				\
	halt='$(_ptm1); $(_ptm2)'					\
	  $(_sc_search_regexp)

# Avoid a test bashism.
sc_prohibit_test_double_equal:
	@prohibit='(\<test| \[+) .+ == '				\
	containing='#! */bin/[a-z]*sh'					\
	halt='use "test x = x", not "test x =''= x"'			\
	  $(_sc_search_regexp)

# Each program that uses proper_name_utf8 must link with one of the
# ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
# The perl -0777 invocation below extracts the possibly-multi-line
# definition of LDADD from the appropriate Makefile.am and exits 0
# when it contains "ICONV".
sc_proper_name_utf8_requires_ICONV:
	@progs=$$($(VC_LIST_EXCEPT)					\
		    | xargs $(GREP) -l 'proper_name_utf8 ''("');	\
	if test "x$$progs" != x; then					\
	  fail=0;							\
	  for p in $$progs; do						\
	    dir=$$(dirname "$$p");					\
	    perl -0777							\
	      -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'	\
	      $$dir/Makefile.am && continue;				\
	    base=$$(basename "$$p" .c);					\
	    $(GREP) "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null	\
	      || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
	  done;								\
	  test $$fail = 1 &&						\
	    { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
	      exit 1; } || :;						\
	fi

# Warn about "c0nst struct Foo const foo[]",
# but not about "char const *const foo" or "#define const const".
sc_redundant_const:
	@prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'		\
	halt='redundant "const" in declarations'			\
	  $(_sc_search_regexp)

sc_const_long_option:
	@prohibit='^ *static.*struct option '				\
	exclude='const struct option|struct option const'		\
	halt='add "const" to the above declarations'			\
	  $(_sc_search_regexp)

NEWS_hash =								\
  $$($(SED) -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'		\
       $(srcdir)/NEWS							\
     | perl -0777 -pe							\
	's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'	\
     | md5sum -								\
     | $(SED) 's/ .*//')

# Update the hash stored above.  Do this after each release and
# for any corrections to old entries.
update-NEWS-hash: NEWS
	perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
	  $(srcdir)/syntax-check.mk

# Ensure that we use only the standard $(VAR) notation,
# not @...@ in Makefile.am, now that we can rely on automake
# to emit a definition for each substituted variable.
# However, there is still one case in which @VAR@ use is not just
# legitimate, but actually required: when augmenting an automake-defined
# variable with a prefix.  For example, gettext uses this:
# MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
# otherwise, makeinfo would put German or French (current locale)
# navigation hints in the otherwise-English documentation.
#
# Allow the package to add exceptions via a hook in syntax-check.mk;
# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
_makefile_at_at_check_exceptions ?=
sc_makefile_at_at_check:
	@perl -ne '/\@\w+\@/'						\
          -e ' && !/(\w+)\s+=.*\@\1\@$$/'				\
          -e ''$(_makefile_at_at_check_exceptions)			\
	  -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'	\
	    $$($(VC_LIST_EXCEPT) | $(GREP) -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
	  && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :

sc_makefile_TAB_only_indentation:
	@prohibit='^	[ ]{8}'						\
	in_vc_files='akefile|\.mk$$'					\
	halt='found TAB-8-space indentation'				\
	  $(_sc_search_regexp)

sc_m4_quote_check:
	@prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'		\
	in_vc_files='(^configure\.ac|\.m4)$$'				\
	halt='quote the first arg to AC_DEF*'				\
	  $(_sc_search_regexp)

1865 1866 1867
gen_source_files:
	$(MAKE) -C src generated-sources

1868 1869 1870 1871 1872 1873 1874 1875 1876 1877 1878 1879 1880 1881 1882 1883 1884 1885 1886 1887 1888
fix_po_file_diag = \
'you have changed the set of files with translatable diagnostics;\n\
apply the above patch\n'

# Generate a list of files in which to search for translatable strings.
perl_translatable_files_list_ =						\
  -e 'foreach $$file (@ARGV) {'						\
  -e '	\# Consider only file extensions with one or two letters'	\
  -e '	$$file =~ /\...?$$/ or next;'					\
  -e '	\# Ignore m4 and mk files'					\
  -e '	$$file =~ /\.m[4k]$$/ and next;'				\
  -e '	\# Ignore a .c or .h file with a corresponding .l or .y file'	\
  -e '	$$file =~ /(.+)\.[ch]$$/ && (-e "$${1}.l" || -e "$${1}.y")'	\
  -e '	  and next;'							\
  -e '	\# Skip unreadable files'					\
  -e '	-r $$file or next;'						\
  -e '	print "$$file ";'						\
  -e '}'

# Verify that all source files using _() (more specifically, files that
# match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
1889
po_file ?= $(srcdir)/po/POTFILES.in
1890 1891

# List of additional files that we want to pick up in our POTFILES.in
1892
# This is all generated files for RPC code.
1893
generated_files = \
1894
  $(builddir)/src/*.[ch] \
1895
  $(builddir)/src/*/*.[ch]
1896

1897
_gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
1898 1899 1900

# sc_po_check can fail if generated files are not built first
sc_po_check: gen_source_files
1901 1902 1903 1904 1905 1906
	@if test -f $(po_file); then					\
	  $(GREP) -E -v '^(#|$$)' $(po_file)				\
	    | $(GREP) -v '^src/false\.c$$' | sort > $@-1;		\
	  { $(VC_LIST_EXCEPT); echo $(generated_files); }		\
	    | xargs perl $(perl_translatable_files_list_)		\
	    | xargs $(GREP) -E -l '$(_gl_translatable_string_re)'	\
1907 1908
	    | $(SED) 's|^$(_dot_escaped_srcdir)|@SRCDIR@|'		\
	    | $(SED) 's|^$(_dot_escaped_builddir)|@BUILDDIR@|'		\
1909 1910 1911 1912 1913 1914 1915 1916 1917 1918 1919 1920 1921 1922 1923 1924 1925 1926 1927 1928 1929 1930 1931 1932 1933 1934 1935 1936 1937 1938 1939 1940 1941 1942 1943 1944 1945 1946 1947 1948 1949 1950 1951 1952 1953 1954 1955 1956 1957 1958 1959 1960 1961 1962 1963 1964 1965 1966 1967 1968 1969 1970 1971 1972 1973 1974 1975 1976 1977
	    | sort -u > $@-2;						\
	  diff -u -L $(po_file) -L $(po_file) $@-1 $@-2			\
	    || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };	\
	  rm -f $@-1 $@-2;						\
	fi

# Check that 'make alpha' will not fail at the end of the process,
# i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
# and is read-only.
writable-files:
	$(AM_V_GEN)if test -d $(release_archive_dir); then		\
	  for file in $(DIST_ARCHIVES); do				\
	    for p in ./ $(release_archive_dir)/; do			\
	      test -e $$p$$file || continue;				\
	      test -w $$p$$file						\
		|| { echo ERROR: $$p$$file is not writable; fail=1; };	\
	    done;							\
	  done;								\
	  test "$$fail" && exit 1 || : ;				\
	else :;								\
	fi


# BRE regex of file contents to identify a test script.
_test_script_regex ?= \<init\.sh\>

# In tests, use "compare expected actual", not the reverse.
sc_prohibit_reversed_compare_failure:
	@prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)'		\
	containing='$(_test_script_regex)'				\
	halt='reversed compare arguments'				\
	  $(_sc_search_regexp)

# #if HAVE_... will evaluate to false for any non numeric string.
# That would be flagged by using -Wundef, however gnulib currently
# tests many undefined macros, and so we can't enable that option.
# So at least preclude common boolean strings as macro values.
sc_Wundef_boolean:
	@prohibit='^#define.*(yes|no|true|false)$$'			\
	in_files='$(CONFIG_INCLUDE)'					\
	halt='Use 0 or 1 for macro values'				\
	  $(_sc_search_regexp)

# Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
# not be constant, or might overflow a stack.  In general, use PATH_MAX as
# a limit, not an array or alloca size.
sc_prohibit_path_max_allocation:
	@prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX'		\
	halt='Avoid stack allocations of size PATH_MAX'			\
	  $(_sc_search_regexp)

sc_vulnerable_makefile_CVE-2009-4029:
	@prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
	in_files='(^|/)Makefile\.in$$'					\
	halt=$$(printf '%s\n'						\
	  'the above files are vulnerable; beware of running'		\
	  '  "make dist*" rules, and upgrade to fixed automake'		\
	  '  see https://bugzilla.redhat.com/show_bug.cgi?id=542609 for details') \
	  $(_sc_search_regexp)

sc_vulnerable_makefile_CVE-2012-3386:
	@prohibit='chmod a\+w \$$\(distdir\)'				\
	in_files='(^|/)Makefile\.in$$'					\
	halt=$$(printf '%s\n'						\
	  'the above files are vulnerable; beware of running'		\
	  '  "make distcheck", and upgrade to fixed automake'		\
	  '  see https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2012-3386 for details') \
	  $(_sc_search_regexp)

1978

1979
ifneq ($(_gl-Makefile),)
1980
syntax-check: spacing-check test-wrap-argv \
1981 1982
	prohibit-duplicate-header mock-noinline group-qemu-caps \
        header-ifdef
1983 1984 1985 1986
	@if ! cppi --version >/dev/null 2>&1; then \
		echo "*****************************************************" >&2; \
		echo "* cppi not installed, some checks have been skipped *" >&2; \
		echo "*****************************************************" >&2; \
S
Shi Lei 已提交
1987 1988 1989 1990 1991
	fi; \
	if [ -z "$(FLAKE8)" ]; then \
		echo "*****************************************************" >&2; \
		echo "* flake8 not installed, sc_flake8 has been skipped  *" >&2; \
		echo "*****************************************************" >&2; \
1992
	fi
1993
endif
1994

1995 1996
# Don't include duplicate header in the source (either *.c or *.h)
prohibit-duplicate-header:
1997 1998
	$(AM_V_GEN)$(VC_LIST_EXCEPT) | $(GREP) '\.[chx]$$' | $(RUNUTF8) xargs \
	$(PYTHON) $(top_srcdir)/scripts/prohibit-duplicate-header.py
1999

2000
spacing-check:
2001 2002
	$(AM_V_GEN)$(VC_LIST) | $(GREP) '\.c$$' | xargs \
	$(PERL) $(top_srcdir)/build-aux/check-spacing.pl || \
2003
	  { echo '$(ME): incorrect formatting' 1>&2; exit 1; }
2004

2005
mock-noinline:
2006 2007
	$(AM_V_GEN)$(VC_LIST) | $(GREP) '\.[ch]$$' | $(RUNUTF8) xargs \
	$(PYTHON) $(top_srcdir)/scripts/mock-noinline.py
2008

2009
header-ifdef:
2010 2011
	$(AM_V_GEN)$(VC_LIST) | $(GREP) '\.[h]$$' | $(RUNUTF8) xargs \
	$(PYTHON) $(top_srcdir)/scripts/header-ifdef.py
2012

2013
test-wrap-argv:
2014 2015
	$(AM_V_GEN)$(VC_LIST) | $(GREP) -E '\.(ldargs|args)' | $(RUNUTF8) xargs \
	$(PYTHON) $(top_srcdir)/scripts/test-wrap-argv.py --check
2016

2017
group-qemu-caps:
2018 2019
	$(AM_V_GEN)$(RUNUTF8) $(PYTHON) $(top_srcdir)/scripts/group-qemu-caps.py \
		--check --prefix $(top_srcdir)/
2020

2021
# List all syntax-check exemptions:
2022
exclude_file_name_regexp--sc_avoid_strcase = ^tools/vsh\.h$$
2023

2024
_src1=libvirt-stream|qemu/qemu_monitor|util/vir(command|file|fdstream)|xen/xend_internal|rpc/virnetsocket|lxc/lxc_controller|locking/lock_daemon|logging/log_daemon
2025
_test1=shunloadtest|virnettlscontexttest|virnettlssessiontest|vircgroupmock|commandhelper
2026
exclude_file_name_regexp--sc_avoid_write = \
2027
  ^(src/($(_src1))|tools/virsh-console|tests/($(_test1)))\.c$$
2028

2029 2030
exclude_file_name_regexp--sc_bindtextdomain = .*

2031
exclude_file_name_regexp--sc_gettext_init = ^((tests|examples)/|tools/virt-login-shell.c|src/util/vireventglib\.c)
2032

2033
exclude_file_name_regexp--sc_copyright_format = \
2034
	^build-aux/syntax-check\.mk$$
2035

2036
exclude_file_name_regexp--sc_copyright_usage = \
2037
  ^COPYING(|\.LESSER)|build-aux/syntax-check.mk$$
2038

2039
exclude_file_name_regexp--sc_flags_usage = \
2040
  ^(build-aux/syntax-check\.mk|docs/|src/util/virnetdevtap\.c$$|tests/((vir(cgroup|pci|test|usb)|nss|qemuxml2argv|qemusecurity)mock|virfilewrapper)\.c$$)
2041

2042
exclude_file_name_regexp--sc_libvirt_unmarked_diagnostics = \
2043
  ^(src/rpc/gendispatch\.pl$$|tests/)
2044

2045
exclude_file_name_regexp--sc_po_check = ^(docs/|src/rpc/gendispatch\.pl$$)
2046 2047

exclude_file_name_regexp--sc_prohibit_VIR_ERR_NO_MEMORY = \
2048
  ^(build-aux/syntax-check\.mk|include/libvirt/virterror\.h|src/remote/remote_daemon_dispatch\.c|src/util/virerror\.c|docs/internals/oomtesting\.html\.in)$$
2049

2050
exclude_file_name_regexp--sc_makefile_TAB_only_indentation = \
2051
  ^build-aux/syntax-check\.mk$$
2052 2053

exclude_file_name_regexp--sc_makefile_at_at_check = \
2054
  ^build-aux/syntax-check\.mk$$
2055

2056
exclude_file_name_regexp--sc_prohibit_PATH_MAX = \
2057
	^build-aux/syntax-check\.mk$$
2058

2059
exclude_file_name_regexp--sc_prohibit_access_xok = \
2060
	^(src/util/virutil\.c)$$
E
Eric Blake 已提交
2061

2062
exclude_file_name_regexp--sc_prohibit_asprintf = \
2063
  ^(build-aux/syntax-check\.mk|bootstrap.conf$$|examples/|src/util/virstring\.[ch]$$|tests/vircgroupmock\.c|tools/virt-login-shell\.c|tools/nss/libvirt_nss\.c$$)
E
Eric Blake 已提交
2064

2065
exclude_file_name_regexp--sc_prohibit_strdup = \
2066
  ^(docs/|examples/|src/util/virstring\.c|tests/vir(netserverclient|cgroup)mock.c|tests/commandhelper\.c|tools/nss/libvirt_nss_(leases|macs)\.c$$)
2067

2068
exclude_file_name_regexp--sc_prohibit_close = \
2069
  (\.p[yl]$$|\.spec\.in$$|^docs/|^(src/util/vir(file|event)\.c|src/libvirt-stream\.c|tests/(vir.+mock\.c|commandhelper\.c|qemusecuritymock\.c)|tools/nss/libvirt_nss_(leases|macs)\.c)$$)
2070 2071

exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF = \
J
Ján Tomko 已提交
2072
  (^tests/(virhostcpu|virpcitest)data/|docs/js/.*\.js|docs/fonts/.*\.woff|\.diff|tests/virconfdata/no-newline\.conf$$)
2073

2074
_src2=src/(util/vircommand|libvirt|lxc/lxc_controller|locking/lock_daemon|logging/log_daemon|remote/remote_daemon)
2075
exclude_file_name_regexp--sc_prohibit_fork_wrappers = \
2076
  (^($(_src2)|tests/testutils)\.c$$)
2077

2078
exclude_file_name_regexp--sc_prohibit_gethostname = ^src/util/vir(util|log)\.c$$
2079

E
Eric Blake 已提交
2080
exclude_file_name_regexp--sc_prohibit_internal_functions = \
2081
  ^src/(util/(viralloc|virutil|virfile)\.[hc]|esx/esx_vi\.c)$$
E
Eric Blake 已提交
2082

2083 2084 2085
exclude_file_name_regexp--sc_prohibit_raw_virclassnew = \
  ^src/util/virobject\.[hc]$$

2086
exclude_file_name_regexp--sc_prohibit_newline_at_end_of_diagnostic = \
2087
  ^src/rpc/gendispatch\.pl$$
2088

2089
exclude_file_name_regexp--sc_prohibit_nonreentrant = \
2090
  ^((po|tests|examples)/|docs/.*(py|js|html\.in)|run.in$$|tools/wireshark/util/genxdrstub\.pl|tools/virt-login-shell\.c$$)
2091

2092
exclude_file_name_regexp--sc_prohibit_select = \
2093
	^build-aux/syntax-check\.mk$$
2094

2095
exclude_file_name_regexp--sc_prohibit_canonicalize_file_name = \
2096
  ^(build-aux/syntax-check\.mk|tests/virfilemock\.c)$$
2097

E
Eric Blake 已提交
2098
exclude_file_name_regexp--sc_prohibit_raw_allocation = \
2099
  ^(docs/hacking\.html\.in|src/util/viralloc\.[ch]|examples/.*|tests/(securityselinuxhelper|(vircgroup|nss)mock|commandhelper)\.c|tools/wireshark/src/packet-libvirt\.c|tools/nss/libvirt_nss(_leases|_macs)?\.c|build-aux/useless-if-before-free)$$
E
Eric Blake 已提交
2100

2101
exclude_file_name_regexp--sc_prohibit_readlink = \
2102
  ^src/(util/virutil|lxc/lxc_container)\.c$$
2103

2104
exclude_file_name_regexp--sc_prohibit_setuid = ^src/util/virutil\.c|tools/virt-login-shell\.c$$
E
Eric Blake 已提交
2105

2106 2107 2108
exclude_file_name_regexp--sc_prohibit_snprintf = \
  ^(build-aux/syntax-check\.mk|docs/hacking\.html\.in|tools/virt-login-shell\.c)$$

2109
exclude_file_name_regexp--sc_prohibit_strncpy = ^src/util/virstring\.c$$
2110

2111
exclude_file_name_regexp--sc_prohibit_strtol = ^examples/.*$$
E
Eric Blake 已提交
2112

2113
exclude_file_name_regexp--sc_prohibit_xmlGetProp = ^src/util/virxml\.c$$
2114

M
Martin Kletzander 已提交
2115 2116
exclude_file_name_regexp--sc_prohibit_xmlURI = ^src/util/viruri\.c$$

2117
exclude_file_name_regexp--sc_prohibit_return_as_function = \.py|build-aux/useless-if-before-free$$
2118

2119
exclude_file_name_regexp--sc_require_config_h = \
2120
	^(examples/|tools/virsh-edit\.c$$|tests/virmockstathelpers.c)
2121

2122
exclude_file_name_regexp--sc_require_config_h_first = \
2123
	^(examples/|tools/virsh-edit\.c$$|tests/virmockstathelpers.c)
2124

2125
exclude_file_name_regexp--sc_trailing_blank = \
2126
  /sysinfodata/.*\.data|/virhostcpudata/.*\.cpuinfo$$
2127 2128

exclude_file_name_regexp--sc_unmarked_diagnostics = \
2129
  ^(scripts/apibuild.py|tests/virt-aa-helper-test|docs/js/.*\.js)$$
2130

2131
exclude_file_name_regexp--sc_size_of_brackets = build-aux/syntax-check\.mk
2132 2133 2134

exclude_file_name_regexp--sc_correct_id_types = \
  (^src/locking/lock_protocol.x$$)
2135 2136

exclude_file_name_regexp--sc_m4_quote_check = m4/virt-lib.m4
2137

2138
exclude_file_name_regexp--sc_prohibit_include_public_headers_quote = \
2139
  ^(src/internal\.h$$|tools/wireshark/src/packet-libvirt.c$$)
2140 2141

exclude_file_name_regexp--sc_prohibit_include_public_headers_brackets = \
2142
  ^(tools/|examples/|include/libvirt/(virterror|libvirt(-(admin|qemu|lxc))?)\.h$$)
2143 2144

exclude_file_name_regexp--sc_prohibit_int_ijk = \
2145
  ^(src/remote_protocol-structs|src/remote/remote_protocol\.x|build-aux/syntax-check\.mk|include/libvirt/libvirt.+|src/admin_protocol-structs|src/admin/admin_protocol\.x)$$
2146

M
Michal Privoznik 已提交
2147 2148 2149
exclude_file_name_regexp--sc_prohibit_unsigned_pid = \
  ^(include/libvirt/.*\.h|src/(qemu/qemu_driver\.c|driver-hypervisor\.h|libvirt(-[a-z]*)?\.c|.*\.x|util/vir(polkit|systemd)\.c)|tests/virpolkittest\.c|tools/virsh-domain\.c)$$

2150
exclude_file_name_regexp--sc_avoid_g_gnuc_unused_in_header = \
M
Martin Kletzander 已提交
2151
  ^(src/util/virlog\.h|src/network/bridge_driver\.h)$$
2152 2153 2154

exclude_file_name_regexp--sc_prohibit_mixed_case_abbreviations = \
  ^src/(vbox/vbox_CAPI.*.h|esx/esx_vi.(c|h)|esx/esx_storage_backend_iscsi.c)$$
2155 2156

exclude_file_name_regexp--sc_prohibit_empty_first_line = \
2157
  ^(README|src/esx/README|tests/(vmwarever|virhostcpu)data/.*)$$
2158 2159 2160

exclude_file_name_regexp--sc_prohibit_useless_translation = \
  ^tests/virpolkittest.c
2161 2162

exclude_file_name_regexp--sc_prohibit_devname = \
2163
  ^(tools/virsh.pod|build-aux/syntax-check\.mk|docs/.*)$$
2164 2165

exclude_file_name_regexp--sc_prohibit_virXXXFree = \
2166
  ^(docs/|tests/|examples/|tools/|build-aux/syntax-check\.mk|src/test/test_driver.c|src/libvirt_public.syms|include/libvirt/libvirt-(domain|network|nodedev|storage|stream|secret|nwfilter|interface|domain-snapshot).h|src/libvirt-(domain|qemu|network|nodedev|storage|stream|secret|nwfilter|interface|domain-snapshot).c|src/qemu/qemu_shim.c$$)
2167 2168

exclude_file_name_regexp--sc_prohibit_sysconf_pagesize = \
2169
  ^(build-aux/syntax-check\.mk|src/util/vir(hostmem|util)\.c)$$
J
Jiri Denemark 已提交
2170 2171

exclude_file_name_regexp--sc_prohibit_pthread_create = \
2172
  ^(build-aux/syntax-check\.mk|src/util/virthread\.c|tests/.*)$$
2173

J
Ján Tomko 已提交
2174
exclude_file_name_regexp--sc_prohibit_readdir = \
2175
  ^(tests/(.*mock|virfilewrapper)\.c|tools/nss/libvirt_nss\.c)$$
2176 2177 2178

exclude_file_name_regexp--sc_prohibit_cross_inclusion = \
  ^(src/util/virclosecallbacks\.h|src/util/virhostdev\.h)$$
2179 2180 2181

exclude_file_name_regexp--sc_prohibit_dirent_d_type = \
  ^(src/util/vircgroup.c)$
2182 2183

exclude_file_name_regexp--sc_prohibit_strcmp = \
2184
  ^(tools/nss/libvirt_nss.*\.c|tools/virt-login-shell\.c)
2185 2186

exclude_file_name_regexp--sc_prohibit_backslash_alignment = \
2187
  ^build-aux/syntax-check\.mk$$
2188

2189 2190
exclude_file_name_regexp--sc_prohibit_select = \
  ^build-aux/syntax-check\.mk|src/util/vireventglibwatch\.c$$